dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local owner_id = getPlayerEntity()
	local entity_id = GetUpdatedEntityID()

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= owner_id) then
		-- Kills projectile that triggered this handler
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/shield_deflect_explosion_pink.xml", x, y)
		
		-- updates absorbed projectiles counter
		local absorbed_projectiles = getInternalVariableValue(entity_id, "absorb_counter", "value_int")
		if(absorbed_projectiles > 10) then
			absorbed_projectiles = 10
		else
			absorbed_projectiles = absorbed_projectiles + 1
		end
		setInternalVariableValue(entity_id, "absorb_counter", "value_int", absorbed_projectiles)
	end

end