dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	local projectile_id = GetUpdatedEntityID()
	
	local shooter_id = getPlayerEntity()
	
	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being redirected
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= shooter_id) then
		
		SetRandomSeed( GameGetFrameNum() + projectile_id, x + y + colliding_entity_id)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/shield_deflect_explosion_purple.xml", x, y)
		
		-- kills colliding projectile
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		-- stores energy for later use
		local energy_store_counter = getInternalVariableValue(projectile_id, "energy_store_counter", "value_int")
		setInternalVariableValue(projectile_id, "energy_store_counter", "value_int", energy_store_counter + 1)
		GamePrint("Defense probe charge: " .. energy_store_counter + 1)
		
	end
end