dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local owner_id = getPlayerEntity()

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being redirected
	if(owner_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= owner_id) then
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/shield_deflect_explosion_pink.xml", x, y)
		
		local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(colliding_entity_id)

		-- Inverts projectile velocity, turning it back to the direction it came
		setProjectileVelocitiesandGravity(colliding_entity_id, (projectile_vel_x + 1.5) * -1, (projectile_vel_y + 1.5) * -1)

		-- Sets the shooter of the deflected projectile as the creature under the effect
		setProjectileShooter(colliding_entity_id, owner_id)

		-- Flags projectile as deflected to prevent it from changing again
		addNewSimplifiedInternalVariable(colliding_entity_id, "deflected")
	end
end