dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "relic")) then return end -- making sure entity that triggered this was a relic
	if(not getInternalVariableValue(colliding_entity_id, "can_be_sold", "value_bool")) then return end -- ignores relics that weren't collected by the player
	if(not isItemDropped(colliding_entity_id)) then return end -- ignores relics that are still in inventory
	
	local machine_x, machine_y = EntityGetTransform(GetUpdatedEntityID())
	local x, y = EntityGetTransform(colliding_entity_id)
	
	if(y < machine_y) then
	
		-- kills relic
		EntityKill(colliding_entity_id)
		
		-- loads audiovisual feedback
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_store_interact_effect.xml", x, y)
		
		-- if relic has no levels, initializes it
		local relic_level = 0
		if(entityHasInternalVariableValue(colliding_entity_id, "relic_level")) then
			relic_level = getInternalVariableValue(colliding_entity_id, "relic_level", "value_int")
		end

		-- adds gold, and adds bonus gold if relic has upgrade levels
		local sell_value = getRelicSellPrice() + (relic_level * 50)
		addPlayerGold(sell_value)
		message = "Relic sold for " .. sell_value .. " gold"
		GamePrint(message)
		GamePrintImportant(message, "", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_store.png")
	end
end