dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	local owner_id = getInternalVariableValue(GetUpdatedEntityID(), "owner", "value_int")

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= owner_id) then
		local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(colliding_entity_id)
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_projectile_lava_shot_explosion.xml", x, y)
		
		local lava_shot_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/magic_orb_lava.xml", x, y)
		
		-- Sets velocities and configures shooter
		setProjectileVelocitiesandGravity(lava_shot_id, (projectile_vel_x / 2) * -1, (projectile_vel_y / 2) * -1)
		setProjectileShooter(lava_shot_id, EntityGetClosestWithTag(  x, y, "enemy"))
		
		-- Flags projectile as deflected to prevent it from changing again
		addNewSimplifiedInternalVariable(lava_shot_id, "deflected")
	end
end