dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	
	SetRandomSeed( GameGetFrameNum(), x + y + colliding_entity_id )

	-- Changes projectile direction randomly
	local angle = math.rad(Random(0,359))
	local length = Random(200,500)

	local vel_x = math.cos( angle ) * length
	local vel_y = 0 - math.sin( angle ) * length
	
	setProjectileVelocitiesandGravity(colliding_entity_id, vel_x, vel_y)
	
	-- Sets player as shooter
	setProjectileShooter(colliding_entity_id, getPlayerEntity())
	
	-- Flags projectile as deflected to prevent it from changing again
	addNewSimplifiedInternalVariable(colliding_entity_id, "deflected")
	
	-- Loads audiovisual feedback
	GamePlaySound( "data/audio/Desktop/animals.snd", "animals/robot/damage/projectile", x, y )
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_disc_bullet_explosion.xml", x, y)

end