dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local entity_id = GetUpdatedEntityID()

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(getProjectileShooter(colliding_entity_id) == getPlayerEntity() or entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	SetRandomSeed( GameGetFrameNum(), x + y + colliding_entity_id )
	
	-- original colliding projectile velocities
	local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(colliding_entity_id)
	
	-- kills colliding projectile
	projectileToggleExplosionOnDeath(colliding_entity_id, false)
	EntityKill(colliding_entity_id)
	
	-- Loads audiovisual feedback
	GamePlaySound( "data/audio/Desktop/animals.snd", "animals/robot/damage/projectile", x, y )
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_disc_bullet_explosion.xml", x, y)
	
	-- Shot projectile handling
	-- ------------------------

	-- Inverts colliding projectile velocity, then loads sawblade and applies velocities to it
	local shot_projectile_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/disc_bullet_medium.xml", x, y)
	setProjectileVelocitiesandGravity(shot_projectile_id, (projectile_vel_x + 1.5) * -1, (projectile_vel_y + 1.5) * -1)

	-- Sets the shooter of the deflected projectile as the creature under the effect
	setProjectileShooter(shot_projectile_id, owner_id)

	-- Flags projectile as deflected to prevent it from changing again
	addNewSimplifiedInternalVariable(shot_projectile_id, "deflected")
	
	-- Kills main projectile
	EntityKill(entity_id)
	
	

end