dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	if(colliding_entity_id == GetUpdatedEntityID()) then return end -- check to prevent it from triggering on itself
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "intercepting_projectile")) then return end -- exclude other intercepting projectiles
	
	projectileToggleExplosionOnDeath(colliding_entity_id, false)
	EntityKill(colliding_entity_id)
	
	-- Loads audiovisual feedback
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/intercepting_laser_explosion.xml", x, y)
	
	-- Kills interceptor rocket
	EntityKill(GetUpdatedEntityID())

end