dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	if(colliding_entity_id == GetUpdatedEntityID()) then return end -- check to prevent it from triggering on itself
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "intercepting_projectile")) then return end -- exclude other intercepting projectiles
	
	-- Loads audiovisual feedback
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/intercepting_laser_explosion.xml", x, y)
	GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/heart/create", x, y )
		
	-- Obtains base damage from colliding projectile then heals player using this value
	local base_damage = getProjectileBaseDamage(colliding_entity_id)
	addPlayerHealth(base_damage * 25, false)
	
	-- damages colliding projectile shooter
	EntityInflictDamage( getProjectileShooter(colliding_entity_id), base_damage, "DAMAGE_MELEE", "First Aid Defense Probe damage penalty", "BLOOD_SPRAY", 0, 0)
	
	-- Kills interceptor projectile
	EntityKill(GetUpdatedEntityID())
	
	-- Kills collinding projectile
	projectileToggleExplosionOnDeath(colliding_entity_id, false)
	EntityKill(colliding_entity_id)

end