dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function collision_trigger(colliding_entity_id)
	
	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)
	
	local stored_relics_amount = 0
	
	local internal_variables = EntityGetComponentIncludingDisabled( entity_id, "VariableStorageComponent" )
	if ( internal_variables ~= nil ) then
		for key,internal_variable in pairs(internal_variables) do
			if(string.find(ComponentGetValue2( internal_variable, "name" ), "stored_relic" )) then
				stored_relics_amount = stored_relics_amount + 1
			end
		end
	end
	
	SetRandomSeed( GameGetFrameNum(), x + y + colliding_entity_id )
	--GamePrint("### stored relics amount: " .. stored_relics_amount)
	
	local bank_size = 10
	
	-- if the player shoots projectiles on it, performs release logic
	if(EntityHasTag(colliding_entity_id, "projectile") and getProjectileShooter(colliding_entity_id) == getPlayerEntity() and not entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then 
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		local internal_variables = EntityGetComponentIncludingDisabled( entity_id, "VariableStorageComponent" )
		if ( internal_variables ~= nil ) then
			for key,internal_variable in pairs(internal_variables) do
				if(string.find(ComponentGetValue2( internal_variable, "name" ), "stored_relic" )) then
					EntityLoad(getRelicsBaseDir() .. ComponentGetValue2( internal_variable, "value_string" ) .. ".xml", x + Random(-5, 5), y + Random(12,14))
					EntityRemoveComponent(entity_id, internal_variable)
				end
			end
		end
	-- if a relic triggers it, performs store logic
	elseif(EntityHasTag(colliding_entity_id, "relic")) then
		if(isItemDropped(colliding_entity_id)) then
			if(stored_relics_amount < bank_size) then
				local variable_index = stored_relics_amount + 1
				local new_variable_name = "stored_relic_" .. variable_index
				addNewInternalVariable(entity_id, new_variable_name, "value_string", EntityGetName(colliding_entity_id))
				local relic_x, relic_y = EntityGetTransform(colliding_entity_id)
				EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/little_chest_relic_store_effect.xml", relic_x, relic_y)
				EntityKill(colliding_entity_id)
			end
		end
	end
end