dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

--GamePrint("### callback fired")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local enemies_in_range = EntityGetInRadiusWithTag(x, y, 15, "enemy")
for i, enemy_id in ipairs(enemies_in_range) do

	--if(not EntityHasTag(enemy_id, "enemy")) then return end -- making sure entity that triggered this was an enemy
	if(isCreatureBoss(enemy_id)) then return end -- if colliding creature is a boss, skips everything below
	if(entityHasSimplifiedInternalVariable(enemy_id, "relic_chest_buff")) then return end -- buffed creatures are excluded from this
	
	--GamePrint("### enemy captured")
	
	-- removes capture handler
	removeCallback(entity_id, "mob_ball_capture")

	-- loads audio visual feedback
	local enemy_x, enemy_y = EntityGetTransform(enemy_id)
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/mob_ball_explosion.xml", enemy_x, enemy_y)
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/mob_ball_explosion.xml", x, y)

	-- kills and stores enemy definition on the mob ball
	EntityKill(enemy_id)
	local captured_enemy_definition = getCreatureDefinitionPath(enemy_id)
	setInternalVariableValue(entity_id, "captured_enemy_definition", "value_string", captured_enemy_definition)

	-- builds captured enemy string
	local captured_enemy_string = " [" .. GameTextGetTranslatedOrNot(EntityGetName(enemy_id)) .. "]"

	-- updates ui info to add what enemy has been captured
	local ic_id = EntityGetFirstComponentIncludingDisabled( entity_id, "ItemComponent" )
	local item_name = ComponentGetValue2(ic_id, "item_name")
	ComponentSetValue2(ic_id, "item_name", item_name .. captured_enemy_string)

	local ac_id = EntityGetFirstComponentIncludingDisabled( entity_id, "AbilityComponent" )
	local ui_name = ComponentGetValue2(ac_id, "ui_name")
	ComponentSetValue2(ac_id, "ui_name", ui_name .. captured_enemy_string)

	local uiic_id = EntityGetFirstComponentIncludingDisabled( entity_id, "UIInfoComponent" )
	local name = ComponentGetValue2(uiic_id, "name")
	ComponentSetValue2(uiic_id, "name", name .. captured_enemy_string)

	-- adds on throw callback to enable spawning captured enemy
	addNewLuaCallback(entity_id, "on_throw", "mods/ArcaneReliquary/files/scripts/other_listeners/mob_ball_drop.lua", 1, false, "mob_ball_drop")
end
