dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	local shield_id = GetUpdatedEntityID()
	
	local shooter_id = getPlayerEntity()
	
	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being redirected
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= shooter_id) then
		
		SetRandomSeed( GameGetFrameNum() + shield_id, x + y + colliding_entity_id)
		
		local projectile_convert_path = getInternalVariableValue(shield_id, "projectile_convert_path", "value_string")
		local destroy_explosion_path = getInternalVariableValue(shield_id, "destroy_explosion_path", "value_string")
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad(destroy_explosion_path, x, y)
		
		-- obtains settings from colliding projectile
		local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(colliding_entity_id)
		local new_default_vel_x = projectile_vel_x * -1 / 2
		local new_default_vel_y = projectile_vel_y * -1 / 2
		
		-- kills colliding projectile
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		local projectile_shot_id = EntityLoad(projectile_convert_path, x, y)
		
		-- Sets velocities and configures shooter
		setProjectileVelocitiesandGravity(projectile_shot_id, new_default_vel_x, new_default_vel_y)
		setProjectileShooter(projectile_shot_id, shooter_id)
		
		-- Flags projectile as deflected to prevent it from changing again
		addNewSimplifiedInternalVariable(projectile_shot_id, "deflected")
	end
end