dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local droid_id = GetUpdatedEntityID()
	local host_id = EntityGetParent(droid_id)
	
	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this is a spell card item
	
	if(getProjectileShooter(colliding_entity_id) == host_id) then return end -- ignores projectiles shot by host entity
	
	-- if captured was shot by an enemy, sets it as the droid's projectile
	if(EntityHasTag(getProjectileShooter(colliding_entity_id), "enemy")) then
		-- obtaining projectile definition from action id
		local projectile_definition = getProjectileDefinitionPath(colliding_entity_id)
		
		if(projectile_definition ~= nil) then -- adds projectile definition only if one exists, this prevents modifiers from getting added
			-- loads audiovisual feedback
			local x, y = EntityGetTransform(colliding_entity_id)
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/programmable_droid_spell_set_effect.xml", x, y)
			projectileToggleExplosionOnDeath(colliding_entity_id, false)
			EntityKill(colliding_entity_id)
		
			-- sets projectile definition to enable shooting
			setInternalVariableValue(droid_id, "projectile_definition", "value_string", projectile_definition)
		end
	end

end
