dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	
	
	local droid_id = GetUpdatedEntityID()
	
	if(not EntityHasTag(colliding_entity_id, "card_action")) then return end -- making sure entity that triggered this is a spell card item
	
	if(isItemforSale(colliding_entity_id)) then return end -- check to prevent spell cards for sale from being captured by the droid
	
	if(isItemDropped(colliding_entity_id)) then -- this prevents non dropped spell cards from getting added
		
		-- obtaining action id from spell card
		local action_id = getActionIdFromSpell(colliding_entity_id)
		
		if not isActionPhysicsBased(action_id) then -- if detected action is not valid, skips everything below
			return 
		end 
		
		-- checks whether there is a projectile and action set, if so, drops it before setting the new one
		local set_action_id = getInternalVariableValue(droid_id, "action_id", "value_string")
		if(set_action_id ~= "") then
			local host_id = EntityGetParent(droid_id)
			local x, y = EntityGetTransform(host_id)
			CreateItemActionEntity( set_action_id, x, y)
		end
		
		
		-- obtaining projectile definition from action id
		local projectile_definition = getProjectileDefinitionFromActionId(action_id)
		
		if(projectile_definition ~= nil) then -- adds projectile definition only if one exists, this prevents modifiers from getting added
			-- loads audiovisual feedback
			local x, y = EntityGetTransform(colliding_entity_id)
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/programmable_droid_spell_set_effect.xml", x, y)
			EntityKill(colliding_entity_id)
		
			-- sets projectile definition to enable shooting
			setInternalVariableValue(droid_id, "projectile_definition", "value_string", projectile_definition)
			setInternalVariableValue(droid_id, "action_id", "value_string", action_id)
		end
	end
end