dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function collision_trigger(colliding_entity_id)

	local machine_id = GetUpdatedEntityID()

	if(not EntityHasTag(colliding_entity_id, "relic_prize_chip")) then return end -- making sure entity that triggered this was a relic prize chip
	-- if relic chip is not dropped, skips it
	if(not isItemDropped(colliding_entity_id)) then return end
	
	-- gets plays worth from chip
	local plays_worth = getInternalVariableValue(colliding_entity_id, "plays_worth", "value_int")
	
	-- kills chip
	local x, y = EntityGetTransform(colliding_entity_id)
	EntityKill(colliding_entity_id)
	
	-- loads audiovisual feedback
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_prize_machine_interact_effect.xml", x, y)
	
	-- obtains and adds plays
	local plays = getInternalVariableValue(machine_id, "plays", "value_int")
	local new_plays = plays + plays_worth
	setInternalVariableValue(machine_id, "plays", "value_int", new_plays)
	GamePrint("Added " .. plays_worth .. " to this Relic Prize Machine (" .. new_plays .. " plays total)")

end