dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function collision_trigger(colliding_entity_id)

	local entity_id = GetUpdatedEntityID()

	if(not EntityHasTag(colliding_entity_id, "relic")) then return end -- making sure entity that triggered this was a relic
	
	if(not isItemDropped(colliding_entity_id)) then return end -- doesn't trigger on relics that are not dropped on the ground
	
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "shuffled_relic")) then return end -- doesn't shuffle already shuffled relic
	
	local x,y = EntityGetTransform(colliding_entity_id)
	EntityKill(colliding_entity_id)
	
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_shuffle_effect.xml", x, y)
	local new_relic_id = EntityLoad(getRelicsBaseDir() .. getRandomRelic().name .. ".xml", x, y)
	addNewSimplifiedInternalVariable(new_relic_id, "shuffled_relic")
end