dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function collision_trigger(colliding_entity_id)

	local machine_id = GetUpdatedEntityID()

	if(not EntityHasTag(colliding_entity_id, "relic_token")) then return end -- making sure entity that triggered this was a relic token
	-- if token is not dropped, skips it
	if(not isItemDropped(colliding_entity_id)) then return end
	
	-- kills token
	local x, y = EntityGetTransform(colliding_entity_id)
	EntityKill(colliding_entity_id)
	
	-- loads audiovisual feedback
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_store_token_interact_effect.xml", x, y)
	
	-- obtains and adds plays
	local tokens = getInternalVariableValue(machine_id, "tokens", "value_int")
	local total_tokens = tokens + 1
	setInternalVariableValue(machine_id, "tokens", "value_int", total_tokens)
	GamePrint("Added " .. 1 .. " Relic Token to this Relic Store (" .. total_tokens .. " tokens total)")

end