dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

-- obtains id of upgrade stone
local upgrade_stone_id = GetUpdatedEntityID()

-- detects relics nearby
local stone_x, stone_y = EntityGetTransform(upgrade_stone_id)
local relics = EntityGetInRadiusWithTag( stone_x, stone_y, 15, "relic" )
		
-- obtains necessary data
local relic_id = relics[1]
local max_upgrade_level = getRelicMaxUpgradeLevel()

-- if relic is currently disabled, skips
if(not getInternalVariableValue(relic_id, "is_active", "value_bool")) then return end
-- non upgradable relics skipped
if(not isRelicUpgradable(EntityGetName(relic_id))) then return end
-- if relic is not dropped, skips
if(not isItemDropped(relic_id)) then return end

-- if relic has no levels, initializes it
if(not entityHasInternalVariableValue(relic_id, "relic_level")) then
	addNewInternalVariable(relic_id, "relic_level", "value_int", 0)
end
-- obtains current relic level
local relic_level = getInternalVariableValue(relic_id, "relic_level", "value_int")
-- obtains how many levels is upgrade stone worth
local levels_worth = getInternalVariableValue(upgrade_stone_id, "levels_worth", "value_int")
-- adjusts new level with addition upgrade stone levels
local new_relic_level = relic_level + levels_worth
if(new_relic_level > max_upgrade_level) then new_relic_level = max_upgrade_level end
-- sets relic level
setRelicLevel(getRelic(EntityGetName(relic_id)), relic_id, new_relic_level)
-- audio visual feedback
local relic_x, relic_y = EntityGetTransform(relic_id)
EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_upgrade_effect.xml", relic_x, relic_y)
-- kills upgrade stone
EntityKill(upgrade_stone_id)
