dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local entity_id = GetUpdatedEntityID()

	local shooter_id = getInternalVariableValue(entity_id, "shooter", "value_int")
	local contact_damage = getInternalVariableValue(entity_id, "contact_damage", "value_float")
	local damage_type = getInternalVariableValue(entity_id, "damage_type", "value_string")
	local damage_text = getInternalVariableValue(entity_id, "damage_text", "value_string")
	local effect_entity_path = getInternalVariableValue(entity_id, "effect_entity_path", "value_string")

	if(not EntityHasTag(colliding_entity_id, "mortal")) then return end -- making sure entity that triggered this was a mortal creature
	if(isCreatureBoss(colliding_entity_id)) then return end -- if colliding creature is a boss, skips everything below
	
	if(colliding_entity_id ~= shooter_id) then
		local x, y = EntityGetTransform(colliding_entity_id)
		
		EntityInflictDamage( colliding_entity_id, contact_damage, damage_type, damage_text, "NONE", 0, 0)	
		LoadGameEffectEntityTo( colliding_entity_id, effect_entity_path)
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
	end
end