dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "enemy")) then return end -- making sure entity that triggered this was an enemy	
	if(isCreatureBoss(colliding_entity_id)) then return end -- if colliding creature is a boss, skips everything below
	
	if(not entityHasSimplifiedInternalVariable(colliding_entity_id, "rotating_projectile_fortune_captured")) then
		
		local projectile_entity_id = GetUpdatedEntityID()
		
		-- removes collision handler temporarily
		removeCollisionTrigger(projectile_entity_id, "rotating_projectile_capture_enemy")
	
		addNewSimplifiedInternalVariable(colliding_entity_id, "rotating_projectile_fortune_captured")
		setInternalVariableValue(projectile_entity_id, "captured_enemy_id", "value_int", colliding_entity_id)
		
		-- GamePrint("### valid collision triggered, creature id: " .. colliding_entity_id)
		
		-- loads audio visual feedback
		local x, y = EntityGetTransform(projectile_entity_id)
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_projectile_fortune_capture_enemy_explosion.xml", x, y)
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		
		-- updates captured enemies count
		local prize_wheel_count = getInternalVariableValue(getPlayerEntity(), "prize_wheel_count", "value_int")
		setInternalVariableValue(getPlayerEntity(), "prize_wheel_count", "value_int", prize_wheel_count + 1)
		
		--GamePrint("### prize_wheel_count: " .. getInternalVariableValue(getPlayerEntity(), "prize_wheel_count", "value_int"))
		
		-- adds callback to captured creature to update prize wheel count if they die
		addNewLuaCallback(colliding_entity_id, "on_death", "mods/ArcaneReliquary/files/scripts/enemies/enemy_death_fortune_wheel_update_count.lua", 1, false, "enemy_death_fortune_wheel_update_count")
	end
end