dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	local projectile_entity = GetUpdatedEntityID()
	
	local owner_id = getInternalVariableValue(projectile_entity, "owner", "value_int")

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- only projectiles shot by entities other than the owner of this projectile are destroyed, other rotating shield projectiles are also ignored
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end

	if(getProjectileShooter(colliding_entity_id) ~= owner_id) then
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_projectile_destroy_explosion.xml", x, y)
		
		local projectile_x, projectile_y = EntityGetTransform(projectile_entity)
		
		-- Kills rotating projectile to trigger its explosion
		EntityKill(projectile_entity)
		
		-- Spawns barrage of red orbs
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/load_on_explosion/launch_circular_projectiles_magic_orbs_red.xml", projectile_x, projectile_y)
		
	end

end