dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local owner_id = getInternalVariableValue(GetUpdatedEntityID(), "owner", "value_int")

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being affected
	if(owner_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	
	if(getProjectileShooter(colliding_entity_id) ~= owner_id) then
		-- applies polymorph effect on shooter
		local shooter_id = getProjectileShooter(colliding_entity_id)
		LoadGameEffectEntityTo( shooter_id, "data/entities/misc/effect_polymorph.xml" )
		
		projectileToggleExplosionOnDeath(colliding_entity_id, false)
		EntityKill(colliding_entity_id)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/rotating_projectile_mutate_explosion.xml", x, y)
	end

end