dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

function collision_trigger(colliding_entity_id)

	if(not EntityHasTag(colliding_entity_id, "projectile")) then return end -- making sure entity that triggered this was a projectile
	
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- conditions to prevent friendly projectiles from being destroyed
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "relic_effect_projectile")) then return end
	if(string.find(EntityGetName(colliding_entity_id), "rotating_shield_projectile")) then return end
	if( getProjectileShooter(colliding_entity_id) == getPlayerEntity()) then return end
	if(entityHasSimplifiedInternalVariable(colliding_entity_id, "deflected")) then return end
	
	local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(colliding_entity_id)
	projectileToggleExplosionOnDeath(colliding_entity_id, false)
	EntityKill(colliding_entity_id)
	
	local shot_back_projectile_definition = getInternalVariableValue(GetUpdatedEntityID(), "shot_back_projectile_definition", "value_string")
	local destroy_explosion_definition = getInternalVariableValue(GetUpdatedEntityID(), "destroy_explosion_definition", "value_string")
	
	-- Loads audiovisual feedback
	GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
	EntityLoad(destroy_explosion_definition, x, y)
	
	local lava_shot_id = EntityLoad(shot_back_projectile_definition, x, y)
			
	setProjectileVelocitiesandGravity(lava_shot_id, (projectile_vel_x / 2) * -1, (projectile_vel_y / 2) * -1)
	setProjectileShooter(lava_shot_id, getPlayerEntity())
	
	-- Flags projectile as deflected to prevent it from changing again
	addNewSimplifiedInternalVariable(lava_shot_id, "deflected")
end