dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local scatter = 0.1

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity(entity_id)
local pos_x, pos_y = EntityGetTransform( entity_id )

local detection_range = 250
local target_tag = "mortal"

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, target_tag)) do
	local valid_target = true
	if(target_tag == "mortal") then
		valid_target = (EntityGetComponent(id, "GenomeDataComponent") ~= nil) and (EntityGetHerdRelation(root_id, id) < 40) and (IsPlayer(root_id) ~= IsPlayer(id))
	end
	-- is target a valid enemy
	if valid_target then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

if not enemy then return end

-- check los
if RaytraceSurfaces(pos_x, pos_y, enemy_x, enemy_y) then return end

-- enemies that are above companion are ignored
if(enemy_y < pos_y) then return end

local valid_horizontal_range = 20
local left_range = pos_x - valid_horizontal_range
local right_range = pos_x + valid_horizontal_range

-- enemies that are not within horizontal range are ignored
if(enemy_x < left_range or enemy_x > right_range) then return end

if(entityHasSimplifiedInternalVariable(EntityGetParent(entity_id), "turtle_shell_damage_flag")) then
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/minions/nuclear_rat.xml", pos_x, pos_y + 5)
	removeSimplifiedInternalVariable(EntityGetParent(entity_id), "turtle_shell_damage_flag")
else
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/minions/bomb_rat.xml", pos_x, pos_y + 5)
end

