dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local scatter = 0.1

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity(entity_id)
local pos_x, pos_y = EntityGetTransform( entity_id )

local projectile_definition = getInternalVariableValue(entity_id, "projectile_definition", "value_string")
local projectile_amount = getInternalVariableValue(entity_id, "projectile_amount", "value_int")
local detection_range = getInternalVariableValue(entity_id, "detection_range", "value_int")
local projectile_velocity_min = getInternalVariableValue(entity_id, "vel_min", "value_int")
local projectile_velocity_max = getInternalVariableValue(entity_id, "vel_max", "value_int")
local target_tag = getInternalVariableValue(entity_id, "target_tag", "value_string")

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
if(target_tag ~= "projectile") then
	for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, target_tag)) do
		local valid_target = true
		if(target_tag == "mortal") then
			valid_target = (EntityGetComponent(id, "GenomeDataComponent") ~= nil) and (EntityGetHerdRelation(root_id, id) < 40) and (IsPlayer(root_id) ~= IsPlayer(id))
		end
		-- is target a valid enemy
		if valid_target then
			local x, y = EntityGetFirstHitboxCenter( id )
			local dist = get_distance(pos_x, pos_y, x, y)
			if dist < min_dist then
				min_dist = dist
				enemy = id
				enemy_x = x
				enemy_y = y
			end
		end
	end
else
	for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, target_tag)) do
		if(getProjectileShooter(id) ~= root_id and not entityHasSimplifiedInternalVariable(id, "intercepting_projectile")) then
			local x, y = EntityGetTransform( id )
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

if not enemy then return end

-- check los
if RaytraceSurfaces(pos_x, pos_y, enemy_x, enemy_y) then return end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
for i=1,projectile_amount do
	-- scatter
	local vx,vy = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

	-- apply velocity & shoot
	vx,vy = vec_mult(vx,vy, rand(projectile_velocity_min, projectile_velocity_max))
	if(EntityGetName(entity_id) == "microrocket_droid") then
		local projectile_id = EntityLoad(projectile_definition, pos_x, pos_y)--shoot_projectile( entity_id, projectile_definition, pos_x, pos_y, vx, vy)
		setProjectileVelocitiesandGravity(projectile_id, vx + Random(-10,10), vy - Random(70,90))
		setProjectileShooter(projectile_id, root_id) -- hacky way to prevent projectiles from hitting the player but also to prevent them from being affected by relics
	else
		local projectile_id = shoot_projectile( entity_id, projectile_definition, pos_x, pos_y, vx, vy)
		setProjectileShooter(projectile_id, root_id) -- hacky way to prevent projectiles from hitting the player but also to prevent them from being affected by relics
	end
end