dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local scatter = 0.1

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity(entity_id)
local pos_x, pos_y = EntityGetTransform( entity_id )

local projectile_definition_short_range = getInternalVariableValue(entity_id, "projectile_definition_short_range", "value_string")
local projectile_amount = getInternalVariableValue(entity_id, "projectile_amount", "value_int")
local detection_range_short = getInternalVariableValue(entity_id, "detection_range_short", "value_int")
local projectile_velocity_min_short = getInternalVariableValue(entity_id, "vel_min_short", "value_int")
local projectile_velocity_max_short = getInternalVariableValue(entity_id, "vel_max_short", "value_int")
local target_tag = getInternalVariableValue(entity_id, "target_tag", "value_string")

-- locate nearest enemy within short detection range
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range_short, target_tag)) do
	local valid_target = true
	if(target_tag == "mortal") then
		valid_target = (EntityGetComponent(id, "GenomeDataComponent") ~= nil) and (EntityGetHerdRelation(root_id, id) < 40) and (IsPlayer(root_id) ~= IsPlayer(id))
	end
	-- is target a valid enemy
	if valid_target then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

if not enemy then return end

-- check los
if RaytraceSurfaces(pos_x, pos_y, enemy_x, enemy_y) then return end

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

local how_many = Random(15,25)
local angle_inc = ( 2 * 3.14159 ) / how_many
local theta = 0

for i=1,how_many do
	local projectile_id = EntityLoad(projectile_definition_short_range , pos_x, pos_y)
	addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
	if(target_tag ~= nil and target_tag == "enemy") then
		setProjectileShooter(projectile_id, EntityGetClosestWithTag(  pos_x, pos_y, "enemy"))
	else
		setProjectileShooter(projectile_id, getPlayerEntity())
	end

	local vel_x = math.cos( theta ) * Random(projectile_velocity_min_short,projectile_velocity_max_short)
	local vel_y = math.sin( theta ) * Random(projectile_velocity_min_short,projectile_velocity_max_short)
	theta = theta + angle_inc

	setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y)
	short_range_shot = true
end
