dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)
local field_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/damaging_field.xml", x, y)

local field_x, field_y = EntityGetTransform(field_id)

local target_tag = ""

if(creatureIs(entity_id) == "enemy") then
	target_tag = "player_unit"
else
	target_tag = "enemy"
end

local creatures = EntityGetInRadiusWithTag(field_x, field_y, 13, target_tag)

-- damages and knocks enemies back
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only knocks back creatures other than the entity under this effect
		-- First obtains velocity of entity under this effect
		local entity_vel_x, entity_vel_y = getCreatureVelocities(entity_id)
		
		-- then applies the same velocity to creature caught within the field
		setCreatureVelocities(creature_id, entity_vel_x, entity_vel_y)
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/shield_damage_explosion_pink.xml", x, y)
		
		-- Deals damage to creature within field
		local damageThreshold = 0.03
		
		EntityInflictDamage( creature_id, damageThreshold, "DAMAGE_MELEE", "knocked back", "NORMAL", 0, 0)
	end	
end



