dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

--GamePrint("### effect running")

local entity_id = GetUpdatedEntityID()
entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id)

local entities = EntityGetInRadius(x, y, 10)

-- gets entities around radius
for i,entity in ipairs(entities) do

	--if(EntityHasTag(entity, "relic") or EntityHasTag(entity, "item_physics")) then return end -- if entity is physics object but is a physics item or a relic from Arcane Reliquary, skips it
	
	if(entityHasSimplifiedInternalVariable(entity, "kick_listener")) then return end -- if entity is already flagged with a kick_listener, and if so, skips it
	
	--GamePrint("### entity found with name " .. EntityGetName(entity))
	
	
	local pisc_id = EntityGetFirstComponentIncludingDisabled( entity, "PhysicsImageShapeComponent" )
	if(pisc_id ~= nil) then
		if(ComponentGetValue2(pisc_id, "image_file") == "data/props_gfx/minecart.png") then
			GamePrint("### minecart found")
		end
	end

	
	-- then tries to obtain physics related components from entity
	--[[
	local pb2c_id = EntityGetFirstComponentIncludingDisabled( entity, "PhysicsBody2Component" )
	local pbc_id = EntityGetFirstComponentIncludingDisabled( entity, "PhysicsBodyComponent" )
	local pisc_id = EntityGetFirstComponentIncludingDisabled( entity, "PhysicsImageShapeComponent" )
	]]
	-- if entity contains these components, it means it is a physics object
	if(pisc_id ~= nil and (pb2c_id ~= nil or pbc_id ~= nil)) then
		
		--GamePrint("### physics object found with name " .. EntityGetName(entity))
		
		--[[


		addNewSimplifiedInternalVariable(entity, "kick_listener")
		
		addNewLuaCallback(entity, "on_kick", "mods/ArcaneReliquary/files/scripts/other_listeners/physics_object_kick.lua", 1, true, "physics_object_kick")
		]]
	end
end



