dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id)

local projectiles = EntityGetInRadiusWithTag(x, y, 17, "projectile")
local chance = 0

-- converts projectiles to ice balls, each projectile caught within radius has a 50% chance of being converted into an ice ball
for i, projectile_id in ipairs(projectiles) do
	for i, component in ipairs(EntityGetComponent(projectile_id, "ProjectileComponent") or {}) do
		if ComponentGetValue2(component, "mWhoShot") ~= entity_id then
			
			if(entityHasSimplifiedInternalVariable(projectile_id, "projectiles_to_ice_checked")) then return end
			
			chance = Random(1,2)
			if(chance == 1) then
				local projectile_x, projectile_y = EntityGetTransform(projectile_id)
				projectileToggleExplosionOnDeath(projectile_id, false)
				EntityKill(projectile_id)
				EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/ice_explosion_tiny.xml", projectile_x, projectile_y)
			else
				addNewSimplifiedInternalVariable( projectile_id, "projectiles_to_ice_checked")
			end
		end
	end
end



