dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)
local field_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/freezing_field.xml", x, y)

local field_x, field_y = EntityGetTransform(field_id)

local target_tag = ""

if(creatureIs(entity_id) == "enemy") then
	target_tag = "player_unit"
else
	target_tag = "enemy"
end

local creatures = EntityGetInRadiusWithTag(field_x, field_y, 13, target_tag)

-- freezes enemies within field
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only applies effect on creatures other than the entity under this effect		
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
		if(Random(1,3) == 1) then -- 30% chance of being frozen
			-- Loads audiovisual feedback
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/shield_damage_explosion_cyan.xml", x, y)
			
			GetGameEffectLoadTo( creature_id, "FROZEN", true )
		end	
	end	
end



