dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()
local explosion_entity_definition = getInternalVariableValue(entity_id, "explosion_entity_definition", "value_string")

local root_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(root_id)

SetRandomSeed( GameGetFrameNum(), x + y + root_id )

local creatures = EntityGetInRadiusWithTag(x, y, 20, "enemy")

-- damages enemies caught
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= root_id) then -- only applies effect on creatures other than the entity under this effect	
		
		-- loads damaging explosion on creature
		local creature_x, creature_y = EntityGetTransform(creature_id)
		EntityLoad(explosion_entity_definition, creature_x, creature_y)
		
		-- inverts current player velocities to simulate knockback
		local root_vel_x, root_vel_y = getCreatureVelocities(root_id)
		setCreatureVelocities(root_id, root_vel_x * -1, root_vel_y * -1)
		
		-- kills effect
		EntityKill(entity_id)
	end	
end

