dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()

local spat_material_name = getInternalVariableValue(entity_id, "spat_material_name", "value_string")
local spit_projectile_definition = getInternalVariableValue(entity_id, "spit_projectile_definition", "value_string")
local spit_projectile_vel_min = getInternalVariableValue(entity_id, "spit_projectile_vel_min", "value_int")
local spit_projectile_vel_max = getInternalVariableValue(entity_id, "spit_projectile_vel_max", "value_int")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

if(entity_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(entity_id, "effects_immune")) then return end -- if the player is under the effect but has immunity to effects, skips effect

--if(isCreatureBoss(entity_id)) then return end -- if creature under effect is a boss, skips it

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local angle = math.rad(Random(0,359))

local projectile_velocity = Random(spit_projectile_vel_min, spit_projectile_vel_max)
local vel_x = math.cos( angle ) * projectile_velocity
local vel_y = 0 - math.sin( angle ) * projectile_velocity

local projectile_id = EntityLoad(spit_projectile_definition, x, y)

local pec_id = EntityGetFirstComponentIncludingDisabled(projectile_id, "ParticleEmitterComponent")
ComponentSetValue2(pec_id, "emitted_material_name", spat_material_name)

setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y) 
addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
setProjectileShooter(projectile_id, entity_id)