dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()

local materials_pool = {
		"oil",
		"blood",
		"poison",
		"water",
		"lava",
		"acid",
		"cement",
		"alcohol",
		"magic_liquid_random_polymorph",
		"magic_liquid_berserk",
		"magic_liquid_teleportation",
		"magic_liquid_hp_regeneration",
		"magic_liquid_polymorph",
		"magic_liquid_movement_faster",
		"magic_liquid_faster_levitation",
		"magic_liquid_charm",
		"magic_liquid_invisibility",
		"magic_liquid_mana_regeneration",
		"magic_liquid_unstable_polymorph",
		"magic_liquid_worm_attractor",
		"magic_liquid_protection_all",
		"radioactive_liquid",
		"radioactive_gas",
		"blood_cold_vapour",
		"blood_cold",
		"smoke",
		"sand",
		"coal",
		"diamond",
		"gunpowder_explosive",
		"slime",
		"corrosive_blood",
		"urine",
		"diamond",
		"silver",
		"liquid_fire"
		--"creepy_liquid",
	}

local spat_material_name = materials_pool[Random(1,#materials_pool)]
local spit_projectile_definition = getInternalVariableValue(entity_id, "spit_projectile_definition", "value_string")
local spit_projectile_vel_min = getInternalVariableValue(entity_id, "spit_projectile_vel_min", "value_int")
local spit_projectile_vel_max = getInternalVariableValue(entity_id, "spit_projectile_vel_max", "value_int")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

if(entity_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(entity_id, "effects_immune")) then return end -- if the player is under the effect but has immunity to effects, skips effect

--if(isCreatureBoss(entity_id)) then return end -- if creature under effect is a boss, skips it

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local angle = math.rad(Random(0,359))

local projectile_velocity = Random(spit_projectile_vel_min, spit_projectile_vel_max)
local vel_x = math.cos( angle ) * projectile_velocity
local vel_y = 0 - math.sin( angle ) * projectile_velocity

local projectile_id = EntityLoad(spit_projectile_definition, x, y)

local pec_id = EntityGetFirstComponentIncludingDisabled(projectile_id, "ParticleEmitterComponent")
ComponentSetValue2(pec_id, "emitted_material_name", spat_material_name)

setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y) 
addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
setProjectileShooter(projectile_id, entity_id)