dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()

local exclude_flying_creatures = getInternalVariableValue(entity_id, "exclude_flying_creatures", "value_bool")
local randomize = getInternalVariableValue(entity_id, "randomize", "value_bool")
local paralysis_timer = getInternalVariableValue(entity_id, "paralysis_timer", "value_int")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

if(entity_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(entity_id, "effects_immune")) then return end -- if the player is under the effect but has immunity to effects, skips effect

-- exclude flying creatures flag
if(exclude_flying_creatures) then
	if(entity_id ~= getPlayerEntity() and enemyFlightEnabled(entity_id)) then return end -- excludes flying enemy creatures
end

if(entityHasSimplifiedInternalVariable(entity_id, "effect_paralyse")) then return end -- excludes creatures already under paralysis effects

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local odds = 1

-- if effect is to be randomized, odds are now 50%
if(randomize) then
	odds = Random(1,2)
end

if(odds == 1) then
	addBuffVisualIndicator(entity_id, "plasma_fading_green", "effect_paralyse")
	addNewSimplifiedInternalVariable(entity_id, "effect_paralyse")
	enemyTogglePlatforming(entity_id, false)
	setCreatureVelocities(entity_id, 0, Random(400,500))
	addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/enemies/reenable_movement.lua", paralysis_timer, true, "reenable_movement")
end
