dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()
local projectile_definition = getInternalVariableValue(entity_id, "projectile_definition", "value_string")
local projectile_velocity_min = getInternalVariableValue(entity_id, "projectile_velocity_min", "value_int")
local projectile_velocity_max = getInternalVariableValue(entity_id, "projectile_velocity_max", "value_int")
local target_image_path = getInternalVariableValue(entity_id, "target_image_path", "value_string")

local gec_id = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")
local effect_lifetime = ComponentGetValue2( gec_id, "frames" )

entity_id = EntityGetRootEntity( entity_id )
local creature_x, creature_y = EntityGetTransform(entity_id)

if(entity_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(entity_id, "effects_immune")) then return end -- if the player is under the effect but has immunity to effects, skips effect

SetRandomSeed( GameGetFrameNum(), creature_x + creature_y + entity_id )

-- sets shooter id according to the category of creature under the effect
if(EntityHasTag(entity_id, "enemy")) then
	shooter_id = getPlayerEntity() -- if creature under effect is an enemy, then the player is the shooter
else
	shooter_id = EntityGetClosestWithTag(  creature_x, creature_y, "enemy" ) -- if creature under effect is not an enemy, then the nearest enemy is the shooter
end

-- adds target sprite effect to creature under effect
if(not entityHasSpriteEffect(entity_id, "target_sprite_effect")) then
	addSpriteEffect(entity_id, target_image_path, 17, 19, effect_lifetime, 0.4, "target_sprite_effect")
end	

local pos_variation = 50
local shoot_x = creature_x + Random(-pos_variation, pos_variation)
local shoot_y = creature_y + Random(-pos_variation, pos_variation)

local vel_x, vel_y = vec_sub(creature_x, creature_y, shoot_x, shoot_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- scatter
local scatter = 0.1
local vx,vy = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vx,vy = vec_mult(vx,vy, rand(projectile_velocity_min, projectile_velocity_max))
local projectile_id = shoot_projectile( entity_id, projectile_definition, shoot_x, shoot_y, vx, vy)
setProjectileShooter(projectile_id, shooter_id) -- hacky way to prevent projectiles from hitting the player but also to prevent them from being affected by relics


