dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

local entity_id    = GetUpdatedEntityID()
local explosion_entity_definition = getInternalVariableValue(entity_id, "explosion_entity_definition", "value_string")
local effect_name_in_effects_list = getInternalVariableValue(entity_id, "effect_name_in_effects_list", "value_string")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local creatures = EntityGetInRadiusWithTag(x, y, 20, "enemy")

-- slashes enemies caught
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only applies effect on creatures other than the entity under this effect		
		local creature_x, creature_y = EntityGetTransform(creature_id)
		EntityLoad(explosion_entity_definition, creature_x, creature_y)
		LoadGameEffectEntityTo( creature_id, getCustomEffect(effect_name_in_effects_list).path )
	end	
end

