dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/load_on_explosion_list.lua")

local entity_id    = GetUpdatedEntityID()
local explosion_entity_definition = getInternalVariableValue(entity_id, "explosion_entity_definition", "value_string")
local elemental_explosion_list_name = getInternalVariableValue(entity_id, "elemental_explosion_list_name", "value_string")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local creatures = EntityGetInRadiusWithTag(x, y, 20, "enemy")

-- slashes enemies caught
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only applies effect on creatures other than the entity under this effect		
		local creature_x, creature_y = EntityGetTransform(creature_id)
		EntityLoad(explosion_entity_definition, creature_x, creature_y)
	end	
end

-- loads material burst
EntityLoad(getLoadOnExplosion(elemental_explosion_list_name).path, x + Random(5, -5), y + Random(5, -5))

