dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()
local explosion_entity_definition = getInternalVariableValue(entity_id, "explosion_entity_definition", "value_string")
local shockwave_projectile_definition = getInternalVariableValue(entity_id, "shockwave_projectile_definition", "value_string")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local creatures = EntityGetInRadiusWithTag(x, y, 20, "enemy")

-- slashes enemies caught
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only applies effect on creatures other than the entity under this effect		
		local creature_x, creature_y = EntityGetTransform(creature_id)
		EntityLoad(explosion_entity_definition, creature_x, creature_y)
	end	
end

-- loads shockwave projectile
local wave_projectile_y_offset = -15
local wave_projectile_velocity = 800
local wave_projectile_id = EntityLoad(shockwave_projectile_definition, x, y + wave_projectile_y_offset)
addNewSimplifiedInternalVariable(wave_projectile_id, "relic_effect_projectile")
setProjectileVelocitiesandGravity(wave_projectile_id, 0, wave_projectile_velocity)
setProjectileShooter(wave_projectile_id, getPlayerEntity())

