dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()
local spectral_wand_definition = getInternalVariableValue(entity_id, "spectral_wand_definition", "value_string")
local target_image_path = getInternalVariableValue(entity_id, "target_image_path", "value_string")

local gec_id = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")
local effect_lifetime = ComponentGetValue2( gec_id, "frames" )

entity_id = EntityGetRootEntity( entity_id )
local creature_x, creature_y = EntityGetTransform(entity_id)

if(entity_id == getPlayerEntity() and entityHasSimplifiedInternalVariable(entity_id, "effects_immune")) then return end -- if the player is under the effect but has immunity to effects, skips effect

SetRandomSeed( GameGetFrameNum(), creature_x + creature_y + entity_id )

-- adds target sprite effect to creature under effect
if(not entityHasSpriteEffect(entity_id, "target_sprite_effect")) then
	addSpriteEffect(entity_id, target_image_path, 17, 19, effect_lifetime, 0.4, "target_sprite_effect")
end	

local pos_variation = 50
local shoot_x = creature_x + Random(-pos_variation, pos_variation)
local shoot_y = creature_y + Random(-pos_variation, pos_variation)

local vel_x, vel_y = vec_sub(creature_x, creature_y, shoot_x, shoot_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

local laser_shooter_id = EntityLoad(spectral_wand_definition, shoot_x, shoot_y)
setProjectileVelocitiesandGravity(laser_shooter_id, vel_x, vel_y)


