dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local pos_x, pos_y = EntityGetTransform(root_id)

local scatter = 0.1
local projectile_shoot_definition = getInternalVariableValue(entity_id, "projectile_shoot_definition", "value_string")
local detection_range = getInternalVariableValue(entity_id, "detection_range", "value_int")
local projectile_velocity = getInternalVariableValue(entity_id, "projectile_velocity", "value_int")
local projectile_amount = getInternalVariableValue(entity_id, "projectile_amount", "value_int")
local status_effect_required = getInternalVariableValue(entity_id, "status_effect_required", "value_string")

local target_tag = ""
if(root_id == getPlayerEntity()) then
	target_tag = "enemy"
else
	target_tag = "player_unit"
end

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, target_tag)) do

	local valid_target = true
	if(target_tag == "enemy") then
		valid_target = (EntityGetComponent(id, "GenomeDataComponent") ~= nil) and (EntityGetHerdRelation(root_id, id) < 40) and (IsPlayer(root_id) ~= IsPlayer(id))
	end
	-- is target a valid enemy
	if valid_target then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

if not enemy then return end

-- check los
if RaytraceSurfacesAndLiquiform(pos_x, pos_y, enemy_x, enemy_y) then return end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

if(status_effect_required ~= "" and GameGetGameEffectCount(root_id, status_effect_required) > 0) then
	SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
	for i=1,projectile_amount do
		-- scatter
		local vx,vy = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

		-- apply velocity & shoot
		vx,vy = vec_mult(vx,vy, projectile_velocity)
		local projectile_id = shoot_projectile( root_id, projectile_shoot_definition, pos_x, pos_y, vx, vy)
		setProjectileShooter(projectile_id, root_id) -- hacky way to prevent projectiles from hitting the player but also to prevent them from being affected by relics
	end
end