dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

local entity_id    = GetUpdatedEntityID()
local explosion_entity_definition = getInternalVariableValue(entity_id, "explosion_entity_definition", "value_string")
local effect_name_in_effects_list = getInternalVariableValue(entity_id, "effect_name_in_effects_list", "value_string")

entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)

if(isCreatureBoss(entity_id)) then return end -- if creature under effect is a boss, skips it

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local creatures = EntityGetInRadiusWithTag(x, y, 20, "enemy")


for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id and not entityHasSimplifiedInternalVariable(creature_id, "uppercut_hit")) then -- only applies effect on creatures other than the entity under this effect
		
		-- tags enemy and sets callback for removal after 10 frames
		addNewSimplifiedInternalVariable( creature_id, "uppercut_hit")
		addNewLuaCallback(creature_id, "overtime", "mods/ArcaneReliquary/files/scripts/enemies/remove_uppercut_hit_tag.lua", 10, true, "remove_uppercut_hit_tag")
		
		-- loads explosion entity onto enemy
		local creature_x, creature_y = EntityGetTransform(creature_id)
		EntityLoad(explosion_entity_definition, creature_x, creature_y)
		
		-- applies upwards momentum to enemies caught, depending on the current movement direction of the player
		local movement = getPlayerHorizontalMovement()
		local horizontal_push = 0
		local vertical_boost = -2500
		if(movement == "right") then
			horizontal_push = 100
		elseif(movement == "left") then
			horizontal_push = -100
		end
		--local vel_x, vel_y = getCreatureVelocities(creature_id)
		setCreatureVelocities(creature_id, horizontal_push, vertical_boost)
		
		-- always applies bonk effect
		LoadGameEffectEntityTo( creature_id, getCustomEffect("effect_bonk_harmful").path )
		if(effect_name_in_effects_list ~= "") then -- applies extra effect if available
			LoadGameEffectEntityTo( creature_id, getCustomEffect(effect_name_in_effects_list).path )
		end
	end	
end