dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform(entity_id)
local projectile_definition = getProjectileDefinitionPath(entity_id)

local players = EntityGetInRadiusWithTag(pos_x, pos_y, 500, "player_unit")

local projectile_velocity = Random(300, 500)
local scatter = 0.1

SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
local max_track_projectiles = Random(1,3)

local counter = 0
for i, enemy_id in ipairs(players) do
	local enemy_x, enemy_y = EntityGetTransform(enemy_id)
	--GamePrint("### enemy nearby at x " .. enemy_x .. " and y " .. enemy_y)

	-- direction
	local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
	vel_x,vel_y = vec_normalize(vel_x, vel_y)

	-- scatter
	SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
	vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

	-- apply velocity & shoot
	vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)
	local new_projectile_id = shoot_projectile( getProjectileShooter(entity_id), projectile_definition, pos_x, pos_y, vel_x, vel_y)
	
	counter = counter + 1
	if(counter == max_track_projectiles) then
		break
	end
end

if(players ~= nil) then
	EntityKill(entity_id)
end



