dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

-- Control variables
local main_id = 1
local how_to_text = 
[[
Drop a relic on the plate with the blue diamond icon
and this machine will break it down into two other
relics that share the same precursor type of the
relic you dropped with half its level, e.g. dropping
a level 10 relic will result in two level 5 relics.

The relic will be consumed, then two relics will
appear above the plates with the green and red
diamond icons.
]]

function getNewId()
	return main_id + 1
end

-- gui elements
local gui_breakdownstation_text = gui_breakdownstation_text or GuiCreate()
local gui_breakdownstation_howto = gui_breakdownstation_howto or GuiCreate()

function renderBreakdownStationGUI()

	-- doesn't render gui if player inventory is open, or if Inventory Bags inventory is currently open or if no machines in range
	local relic_breakdown_station_id = isPlayerInRangeofMachine("relic_breakdown_station", 30)
	if(isInventoryOpen() or isInventoryBagsOpen() or (relic_breakdown_station_id == nil)) then
		--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "1") -- machine gui can't render, main gui can render again
		return 
	end
	
	-- main gui is hidden when this gui is showing
	--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "0")
	
	GuiStartFrame(gui_breakdownstation_text);
	GuiLayoutBeginVertical( gui_breakdownstation_text, 23, 65);
	GuiText( gui_breakdownstation_text, 40, 2, "Hover over the ? icon to learn \nhow to operate the Relic Breakdown Station.")
	GuiLayoutEnd( gui_breakdownstation_text );
	
	-- how to button
	GuiStartFrame(gui_breakdownstation_howto);
	GuiLayoutBeginVertical( gui_breakdownstation_howto, 30, 61);
	GuiImage( gui_breakdownstation_howto, getNewId(), -4, 0, getGUIIconsPath() .. "howto_icon.png", 1, 1)
	GuiTooltip(gui_breakdownstation_howto, how_to_text, "")
	GuiLayoutEnd( gui_breakdownstation_howto );


end

if gui_breakdownstation_text then 
	async_loop(
		function() 
			renderBreakdownStationGUI()
			wait(0)
		end
	)
end
