dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

-- Control variables
local main_id = 1
local how_to_text = 
[[
Drop a relic on the plate with the blue diamond icon
and this machine will recycle it into a relic metal 
chunk and a container with precursor material 
corresponding to the precursor type of the relic you dropped.

The relic will be consumed, then a relic metal chunk will
spawn on the plate to the right, and a precursor material 
container will spawn on the plate to the left.
]]

function getNewId()
	return main_id + 1
end

-- gui elements
local gui_recyclestation_text = gui_recyclestation_text or GuiCreate()
local gui_recyclestation_howto = gui_recyclestation_howto or GuiCreate()

function renderRecycleStationGUI()

	-- doesn't render gui if player inventory is open, or if Inventory Bags inventory is currently open or if no machines in range
	local relic_recycle_station_id = isPlayerInRangeofMachine("relic_recycle_station", 30)
	if(isInventoryOpen() or isInventoryBagsOpen() or (relic_recycle_station_id == nil)) then
		--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "1") -- machine gui can't render, main gui can render again
		return 
	end
	
	-- main gui is hidden when this gui is showing
	--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "0")
	
	GuiStartFrame(gui_recyclestation_text);
	GuiLayoutBeginVertical( gui_recyclestation_text, 23, 65);
	GuiText( gui_recyclestation_text, 40, 2, "Hover over the ? icon to learn \nhow to operate the Relic Recycle Station.")
	GuiLayoutEnd( gui_recyclestation_text );
	
	-- how to button
	GuiStartFrame(gui_recyclestation_howto);
	GuiLayoutBeginVertical( gui_recyclestation_howto, 30, 61);
	GuiImage( gui_recyclestation_howto, getNewId(), -4, 0, getGUIIconsPath() .. "howto_icon.png", 1, 1)
	GuiTooltip(gui_recyclestation_howto, how_to_text, "")
	GuiLayoutEnd( gui_recyclestation_howto );


end

if gui_recyclestation_text then 
	async_loop(
		function() 
			renderRecycleStationGUI()
			wait(0)
		end
	)
end
