dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

-- Control variables
local main_id = 1
local how_to_text = "Play slots game for a chance to win various prizes. \nDeposit relic prize chips or tokens to in order to play. \nThis machine has "

local default_height = 40
local default_slot1_x = 47
local default_slot2_x = 50
local default_slot3_x = 53
local default_lever_x = 56


local combinations_rewards = {
	-- chest rewards
	-- -------------
	-- best tier
	{ slot1 = 1, slot2 = 1, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_chaotic.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 4, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_chaotic.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 4, slot2 = 1, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_chaotic.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 4, slot2 = 4, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_chaotic.xml", amount = 1, reward_type = "chest" },
	-- middle tier
	{ slot1 = 1, slot2 = 1, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 4, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 4, slot2 = 1, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 1, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 5, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 1, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 1, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 6, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 1, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_great.xml", amount = 1, reward_type = "chest" },
	-- lower tier
	{ slot1 = 1, slot2 = 4, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 4, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 5, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 5, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 6, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 6, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 1, slot2 = 6, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	
	{ slot1 = 4, slot2 = 1, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 4, slot2 = 1, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 1, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 1, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 1, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 1, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 1, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 1, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/relic_chest.xml", amount = 1, reward_type = "chest" },
	
	{ slot1 = 4, slot2 = 5, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 4, slot2 = 6, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 4, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 5, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 5, slot2 = 6, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 4, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 5, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	{ slot1 = 6, slot2 = 6, slot3 = 1, reward_item = "mods/ArcaneReliquary/files/entity_definitions/props/utility_items_chest.xml", amount = 1, reward_type = "chest" },
	-- -------------
	
	-- chip / token rewards
	-- --------------------
	-- best tier
	{ slot1 = 2, slot2 = 2, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 4, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 4, slot2 = 4, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 4, slot2 = 2, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", amount = 1, reward_type = "chip" },
	-- middle tier
	{ slot1 = 2, slot2 = 2, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 4, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 4, slot2 = 2, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 2, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 5, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 2, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 2, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 6, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 2, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_3.xml", amount = 1, reward_type = "chip" },
	-- lower tier
	{ slot1 = 2, slot2 = 4, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 4, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 5, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 5, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 6, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 6, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 2, slot2 = 6, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	
	{ slot1 = 4, slot2 = 2, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 4, slot2 = 2, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 2, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 2, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 2, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 2, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 2, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 2, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip_2.xml", amount = 1, reward_type = "chip" },
	
	{ slot1 = 4, slot2 = 5, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 4, slot2 = 6, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 4, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 5, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 5, slot2 = 6, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 4, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 5, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	{ slot1 = 6, slot2 = 6, slot3 = 2, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/relic_prize_chip.xml", amount = 1, reward_type = "chip" },
	-- --------------------
	
	-- chest key rewards
	-- -----------------
	-- best tier
	{ slot1 = 8, slot2 = 8, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_black.xml", amount = 2, reward_type = "key" },
	{ slot1 = 8, slot2 = 4, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_black.xml", amount = 2, reward_type = "key" },
	{ slot1 = 4, slot2 = 4, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_black.xml", amount = 2, reward_type = "key" },
	{ slot1 = 4, slot2 = 8, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_black.xml", amount = 2, reward_type = "key" },
	-- middle tier
	{ slot1 = 8, slot2 = 8, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 8, slot2 = 4, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 4, slot2 = 8, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 8, slot2 = 8, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, eward_type = "key" },
	{ slot1 = 8, slot2 = 5, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 5, slot2 = 8, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 8, slot2 = 8, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 8, slot2 = 6, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	{ slot1 = 6, slot2 = 8, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 2, reward_type = "key" },
	-- lower tier
	{ slot1 = 8, slot2 = 4, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 4, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 5, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 5, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 6, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 6, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 8, slot2 = 6, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	
	{ slot1 = 4, slot2 = 8, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 4, slot2 = 8, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 8, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 8, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 8, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 8, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 8, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 8, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_purple.xml", amount = 1, reward_type = "key" },
	
	{ slot1 = 4, slot2 = 5, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 4, slot2 = 6, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 4, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 5, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 5, slot2 = 6, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 4, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 5, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	{ slot1 = 6, slot2 = 6, slot3 = 8, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/chest_key_red.xml", amount = 1, reward_type = "key" },
	-- -----------------
	
	-- upgrade stone rewards
	-- -----------------
	-- best tier
	{ slot1 = 9, slot2 = 9, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_3.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 4, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_3.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 4, slot2 = 4, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_3.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 4, slot2 = 9, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_3.xml", amount = 2, reward_type = "upgrade_stone" },
	-- middle tier
	{ slot1 = 9, slot2 = 9, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 4, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 4, slot2 = 9, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 9, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, eward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 5, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 9, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 9, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 6, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 9, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 2, reward_type = "upgrade_stone" },
	-- lower tier
	{ slot1 = 9, slot2 = 4, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 4, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 5, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 5, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 6, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 6, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 9, slot2 = 6, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	
	{ slot1 = 4, slot2 = 9, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 4, slot2 = 9, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 9, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 9, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 9, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 9, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 9, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 9, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone_2.xml", amount = 1, reward_type = "upgrade_stone" },
	
	{ slot1 = 4, slot2 = 5, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 4, slot2 = 6, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 4, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 5, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 5, slot2 = 6, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 4, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 5, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	{ slot1 = 6, slot2 = 6, slot3 = 9, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/upgrade_stone.xml", amount = 1, reward_type = "upgrade_stone" },
	-- -----------------
	
	-- relic rewards
	-- -------------
	-- best tier
	{ slot1 = 3, slot2 = 3, slot3 = 3, reward_item = "level_10_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 4, slot2 = 4, slot3 = 3, reward_item = "level_10_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 4, slot3 = 4, reward_item = "level_10_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 4, slot2 = 3, slot3 = 4, reward_item = "level_10_relic", amount = 1, reward_type = "relic" },
	-- middle tier
	{ slot1 = 3, slot2 = 3, slot3 = 4, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 3, slot2 = 4, slot3 = 3, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 4, slot2 = 3, slot3 = 3, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 3, slot2 = 3, slot3 = 5, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 3, slot2 = 5, slot3 = 3, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 5, slot2 = 3, slot3 = 3, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 3, slot2 = 3, slot3 = 6, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 3, slot2 = 6, slot3 = 1, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 6, slot2 = 3, slot3 = 3, reward_item = "random_leveled_relic", amount = 2, reward_type = "relic" },
	-- lower tier
	{ slot1 = 3, slot2 = 4, slot3 = 5, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 4, slot3 = 6, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 5, slot3 = 4, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 5, slot3 = 5, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 5, slot3 = 6, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 6, slot3 = 4, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 6, slot3 = 5, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 3, slot2 = 6, slot3 = 6, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	
	{ slot1 = 4, slot2 = 3, slot3 = 5, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 4, slot2 = 3, slot3 = 6, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 5, slot2 = 3, slot3 = 4, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 5, slot2 = 3, slot3 = 5, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 5, slot2 = 3, slot3 = 6, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 6, slot2 = 3, slot3 = 4, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 6, slot2 = 3, slot3 = 5, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	{ slot1 = 6, slot2 = 3, slot3 = 6, reward_item = "non_leveled_relic", amount = 2, reward_type = "relic" },
	
	{ slot1 = 4, slot2 = 5, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 4, slot2 = 6, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 5, slot2 = 4, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 5, slot2 = 5, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 5, slot2 = 6, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 6, slot2 = 4, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 6, slot2 = 5, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	{ slot1 = 6, slot2 = 6, slot3 = 3, reward_item = "non_leveled_relic", amount = 1, reward_type = "relic" },
	-- -------------
	
	-- generic rewards
	
	-- gold
	{ slot1 = 4, slot2 = 4, slot3 = 4, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 10, reward_type = "gold" },
	
	{ slot1 = 4, slot2 = 4, slot3 = 5, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	{ slot1 = 4, slot2 = 4, slot3 = 6, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	{ slot1 = 4, slot2 = 5, slot3 = 4, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	{ slot1 = 4, slot2 = 6, slot3 = 4, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	{ slot1 = 5, slot2 = 4, slot3 = 4, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	{ slot1 = 6, slot2 = 4, slot3 = 4, reward_item = "data/entities/items/pickup/goldnugget_10.xml", amount = 5, reward_type = "gold" },
	
	-- healing nuggets
	{ slot1 = 5, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 10, reward_type = "healingnugget" },
	
	{ slot1 = 5, slot2 = 5, slot3 = 4, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
	{ slot1 = 5, slot2 = 5, slot3 = 6, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
	{ slot1 = 5, slot2 = 4, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
	{ slot1 = 5, slot2 = 6, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
	{ slot1 = 4, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
	{ slot1 = 6, slot2 = 5, slot3 = 5, reward_item = "mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", amount = 5, reward_type = "healingnugget" },
}


local slot_states = {
	{ id = 1, pic = "slot_chest.png" },
	{ id = 2, pic = "slot_chip.png" },
	{ id = 3, pic = "slot_relic.png" },
	{ id = 4, pic = "slot_gold.png" },
	{ id = 5, pic = "slot_green.png" },
	{ id = 6, pic = "slot_blue.png" },
	{ id = 7, pic = "slot_nothing.png" },
	{ id = 8, pic = "slot_key.png" },
	{ id = 9, pic = "slot_upgrade_stone.png" },
}

local lever_states = {
	{ id = 1, pic = "lever.png" },
	{ id = 2, pic = "lever_down.png" },
}

local slot1_state = { id = 10, pic = "slot_empty.png" }
local slot2_state = { id = 10, pic = "slot_empty.png" }
local slot3_state = { id = 10, pic = "slot_empty.png" }
local lever_state = lever_states[1]

local game_triggered = false
local game_triggered_frame = 0

local delay_until_slot_states_check = 165
local default_slot3_switch_counter = 135
local default_slot2_switch_counter = 85
local default_slot1_switch_counter = 35
local slot1_switch_counter = default_slot1_switch_counter
local slot2_switch_counter = default_slot2_switch_counter
local slot3_switch_counter = default_slot3_switch_counter

function getNewId()
	return main_id + 1
end

-- Prize machine gui elements settings

local gui_slot1 = gui_slot1 or GuiCreate()
local gui_slot2 = gui_slot2 or GuiCreate()
local gui_slot3 = gui_slot3 or GuiCreate()
local gui_lever = gui_lever or GuiCreate()

local gui_slot_machine_howto = gui_slot_machine_howto or GuiCreate()

function resetGame()
	slot1_switch_counter = default_slot1_switch_counter
	slot2_switch_counter = default_slot2_switch_counter
	slot3_switch_counter = default_slot3_switch_counter
	game_triggered = false
end

function checkSlotStates(slot_machine_id)
	
	--GamePrint (">>> current combination: " .. slot1_state.id .. "|" .. slot2_state.id .. "|" .. slot3_state.id)

	local combination_found = false
	
	-- loops through list of combinations
	for i,combination_reward in ipairs(combinations_rewards) do
		-- if slot states match a combination in the list of rewards, a prize will be dispensed
		if(combination_reward.slot1 == slot1_state.id and combination_reward.slot2 == slot2_state.id and combination_reward.slot3 == slot3_state.id) then
			combination_found = true
			for i=1,combination_reward.amount do
				dispensePrize(combination_reward.reward_item, combination_reward.reward_type, slot_machine_id)
			end
		end
	end
	
	local message = ""
	if(combination_found) then
		-- shows message
		message = "Congratulations"				
		GamePrint(message)
		GamePrintImportant(message, "Prize dispensed", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_claw_success.png")
	else
		-- shows message
		message = "Try again"				
		GamePrint(message)
		GamePrintImportant(message, "Better luck next time", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_claw_fail.png")
		-- loads audio feedback
		local x, y = EntityGetTransform(slot_machine_id)
		GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest_bad/create", x, y )
	end

end

function dispensePrize(item, prize_type, slot_machine_id)
	
	-- determines best place to spawn prize
	local spawn_coordinate_x, spawn_coordinate_y = getBestSpawnCoordinatesNexttoMachine(slot_machine_id)
	-- loads audiovisual feedback
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_store_interact_effect.xml", spawn_coordinate_x, spawn_coordinate_y)
	-- determines which prize will be spawned
	if(prize_type ~= "relic") then
		EntityLoad(item, spawn_coordinate_x, spawn_coordinate_y)
	else -- prize_type is "chest", "chip", "gold" or "healingnugget"
		if(item == "level_10_relic") then
			local relic = getRandomUpgradableRelic()
			local relic_id = EntityLoad(getRelicsBaseDir() .. relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
			setRelicLevel(relic, relic_id, 10)

		elseif(item == "random_leveled_relic") then
			local relic = getRandomUpgradableRelic()
			local relic_id = EntityLoad(getRelicsBaseDir() .. relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
			setRelicLevel(relic, relic_id, Random(1,getRelicMaxUpgradeLevel()))

		elseif(item == "non_leveled_relic") then
			local relic = getRandomRelic()
			local relic_id = EntityLoad(getRelicsBaseDir() .. relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		end
	end
end

function renderSlotMachineGUI()

	-- doesn't render gui if player inventory is open, or if Inventory Bags inventory is currently open or if no slot machines in range
	local slot_machine_id = isPlayerInRangeofMachine("relic_slot_machine", 30)
	local x, y = EntityGetTransform(slot_machine_id)
	if(isInventoryOpen() or isInventoryBagsOpen() or (slot_machine_id == nil)) then
		GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "1") -- machine gui can't render, main gui can render again
		return 
	end
	
	-- main gui is hidden when this gui is showing
	GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "0")
	
	-- obtains number of plays left in slot machine in range
	local plays = getInternalVariableValue(slot_machine_id, "plays", "value_int")
	
	
	-- lever controls and animations
	--------------------------------
	-- lever switches back to regular state if at least 20 frames have passed
	local actual_frame = GameGetFrameNum()
	if(game_triggered and actual_frame - game_triggered_frame >= 20) then
		lever_state = lever_states[1]
	end
	
	-- interaction key lever control
	--local cc_id = EntityGetFirstComponent(getPlayerEntity(), "ControlsComponent")
	--local interact_triggered = ComponentGetValueInt( cc_id, "mButtonFrameInteract" ) == GameGetFrameNum()
	
	-- lever gui and control
	GuiStartFrame(gui_lever);
	GuiLayoutBeginVertical( gui_lever, default_lever_x, default_height);
	if(GuiImageButton( gui_lever, getNewId(), -4, 0, "", getGUIIconsPath() .. lever_state.pic )) then -- lever was clicked or interaction key was pressed
		if(plays >= 1) then
			if(not game_triggered) then
				lever_state = lever_states[2] -- switches to lever_down state
				game_triggered = true -- flags game active
				game_triggered_frame = GameGetFrameNum() -- gets frame for later use
				GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest/create", x, y )
				-- deducts one play from machine
				setInternalVariableValue(slot_machine_id, "plays", "value_int", plays - 1)
			end
		else
			-- shows fail message
			message = "No plays left in this machine"				
			GamePrint(message)
			GamePrintImportant(message, "Deposit more Relic Prize Chips in this machine to get more plays", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_claw_fail.png")
			-- loads audio feedback
			GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest_bad/create", x, y )
		end
	end
	--GuiTooltip(gui_lever, "", "")
	GuiLayoutEnd( gui_lever );
	--------------------------------
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	
	-- slot 1 gui and controls
	--------------------------
	if(game_triggered and slot1_switch_counter > 0) then
		slot1_state = slot_states[Random(1,#slot_states)]
		slot1_switch_counter = slot1_switch_counter - 1
		if(slot1_switch_counter == 0) then
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y)
		end
	end
	
	GuiStartFrame(gui_slot1);
	GuiLayoutBeginVertical( gui_slot1, default_slot1_x, default_height);
	GuiImage( gui_slot1, getNewId(), -4, 0, getGUIIconsPath() .. slot1_state.pic, 1, 1)
	GuiLayoutEnd( gui_slot1 );
	--------------------------
	
	-- slot 2 gui and controls
	--------------------------
	if(game_triggered and slot2_switch_counter > 0) then
		slot2_state = slot_states[Random(1,#slot_states)]
		slot2_switch_counter = slot2_switch_counter - 1
		if(slot2_switch_counter == 0) then
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y)
		end
	end
	
	GuiStartFrame(gui_slot2);
	GuiLayoutBeginVertical( gui_slot2, default_slot2_x, default_height);
	GuiImage( gui_slot2, getNewId(), -4, 0, getGUIIconsPath() .. slot2_state.pic, 1, 1)
	GuiLayoutEnd( gui_slot2 );
	--------------------------
	
	-- slot 3 gui and controls
	--------------------------
	if(game_triggered and slot3_switch_counter > 0) then
		slot3_state = slot_states[Random(1,#slot_states)]
		slot3_switch_counter = slot3_switch_counter - 1
		if(slot3_switch_counter == 0) then
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y)
		end
	end
	
	GuiStartFrame(gui_slot3);
	GuiLayoutBeginVertical( gui_slot3, default_slot3_x, default_height);
	GuiImage( gui_slot3, getNewId(), -4, 0, getGUIIconsPath() .. slot3_state.pic, 1, 1)
	GuiLayoutEnd( gui_slot3 );
	--------------------------
	
	-- all slots stopped switching, checks slot states to determine reward and resets the game
	actual_frame = GameGetFrameNum()
	if(slot1_switch_counter == 0 and slot2_switch_counter == 0 and slot3_switch_counter == 0) then
		if(actual_frame - game_triggered_frame >= delay_until_slot_states_check) then
			checkSlotStates(slot_machine_id)
			resetGame()
		end
	end
	
	-- instruction text
	GuiStartFrame(gui_slot_machine_howto);
	GuiLayoutBeginVertical( gui_slot_machine_howto, 50, 45);
	GuiImage( gui_slot_machine_howto, getNewId(), -4, 0, getGUIIconsPath() .. "howto_icon.png", 1, 1)
	GuiTooltip(gui_slot_machine_howto, how_to_text .. plays .. " plays left.", "")
	GuiLayoutEnd( gui_slot_machine_howto );

end

if gui_slot_machine_howto then 
	async_loop(
		function() 
			renderSlotMachineGUI()
			wait(0)
		end
	)
end