dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

-- Control variables
local main_id = 1
local how_to_text = 
[[
Drop a relic on the plate with the blue diamond
icon. This machine will then automatically
transmute it into another relic of the same 
precursor type, destroying the one you dropped 
and spawning another one on the plate with the 
green diamond icon.
]]

function getNewId()
	return main_id + 1
end

-- gui elements
local gui_transmutestation_text = gui_transmutestation_text or GuiCreate()
local gui_transmutestation_howto = gui_transmutestation_howto or GuiCreate()

function renderTransmuteStationGUI()

	-- doesn't render gui if player inventory is open, or if Inventory Bags inventory is currently open or if no machines in range
	local relic_transmute_station_id = isPlayerInRangeofMachine("relic_transmute_station", 30)
	if(isInventoryOpen() or isInventoryBagsOpen() or (relic_transmute_station_id == nil)) then
		--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "1") -- machine gui can't render, main gui can render again
		return 
	end
	
	-- main gui is hidden when this gui is showing
	--GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "0")
	
	GuiStartFrame(gui_transmutestation_text);
	GuiLayoutBeginVertical( gui_transmutestation_text, 23, 65);
	GuiText( gui_transmutestation_text, 40, 2, "Hover over the ? icon to learn \nhow to operate the Relic Transmute Station.")
	GuiLayoutEnd( gui_transmutestation_text );
	
	-- how to button
	GuiStartFrame(gui_transmutestation_howto);
	GuiLayoutBeginVertical( gui_transmutestation_howto, 30, 61);
	GuiImage( gui_transmutestation_howto, getNewId(), -4, 0, getGUIIconsPath() .. "howto_icon.png", 1, 1)
	GuiTooltip(gui_transmutestation_howto, how_to_text, "")
	GuiLayoutEnd( gui_transmutestation_howto );


end

if gui_transmutestation_text then 
	async_loop(
		function() 
			renderTransmuteStationGUI()
			wait(0)
		end
	)
end
