-- this file controls aspects related to relic forging such as materials and relic categories associated with these materials
-- each material must be associated with a single precursor type
relic_precursor_materials_list =
{
	{
		related_item = "relic_precursor_container_red.xml",
		precursor_material_name = "relic_precursor_red",
		precursor_type = "boot",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_red.png",
		precursor_ui_name = "Red (Boot)",
	},
	{
		related_item = "relic_precursor_container_purple.xml",
		precursor_material_name = "relic_precursor_purple",
		precursor_type = "gravity_stone",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_purple.png",
		precursor_ui_name = "Purple (Gravity Stone)",
	},
	{
		related_item = "relic_precursor_container_green.xml",
		precursor_material_name = "relic_precursor_green",
		precursor_type = "necklace",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_green.png",
		precursor_ui_name = "Green (Necklace)",
	},
	{
		related_item = "relic_precursor_container_yellow.xml",
		precursor_material_name = "relic_precursor_yellow",
		precursor_type = "death_ray",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_yellow.png",
		precursor_ui_name = "Yellow (Death Ray)",
	},
	{
		related_item = "relic_precursor_container_white.xml",
		precursor_material_name = "relic_precursor_white",
		precursor_type = "effect_stone",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_white.png",
		precursor_ui_name = "White (Effect Stone)",
	},
	{
		related_item = "relic_precursor_container_orange.xml",
		precursor_material_name = "relic_precursor_orange",
		precursor_type = "effect_crystal",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_orange.png",
		precursor_ui_name = "Orange (Effect Crystal)",
	},
	{
		related_item = "relic_precursor_container_pink.xml",
		precursor_material_name = "relic_precursor_pink",
		precursor_type = "companion",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_pink.png",
		precursor_ui_name = "Pink (Companion)",
	},
	{
		related_item = "relic_precursor_container_brown.xml",
		precursor_material_name = "relic_precursor_brown",
		precursor_type = "elemental_gem",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_brown.png",
		precursor_ui_name = "Brown (Elemental Gem)",
	},
	{
		related_item = "relic_precursor_container_cyan.xml",
		precursor_material_name = "relic_precursor_cyan",
		precursor_type = "flask",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_cyan.png",
		precursor_ui_name = "Cyan (Flask)",
	},
	{
		related_item = "relic_precursor_container_blue.xml",
		precursor_material_name = "relic_precursor_blue",
		precursor_type = "ring",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_blue.png",
		precursor_ui_name = "Blue (Ring)",
	},
	{
		related_item = "relic_precursor_container_teal.xml",
		precursor_material_name = "relic_precursor_teal",
		precursor_type = "gadget",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_teal.png",
		precursor_ui_name = "Teal (Gadget)",
	},
	{
		related_item = "relic_precursor_container_ruby.xml",
		precursor_material_name = "relic_precursor_ruby",
		precursor_type = "magic_artifact",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_ruby.png",
		precursor_ui_name = "Ruby (Magic Artifact)",
	},
	{
		related_item = "relic_precursor_container_lime.xml",
		precursor_material_name = "relic_precursor_lime",
		precursor_type = "device",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_lime.png",
		precursor_ui_name = "Lime (Device)",
	},
	{
		related_item = "relic_precursor_container_orange_flame.xml",
		precursor_material_name = "relic_precursor_orange_flame",
		precursor_type = "energy_shield",
		icon_path = "mods/ArcaneReliquary/files/other_items_gfx/relic_precursor_container_orange_flame.png",
		precursor_ui_name = "Flame Orange (Energy Shield)",
	},
}

function getPrecursorItemByType(precursor_type)
	local foundItem = nil
	for i,item in ipairs(relic_precursor_materials_list) do
		if(item.precursor_type == precursor_type) then
			foundItem = item
			break
		end
	end
	return foundItem
end

function getRelicPrecursorMaterialsList()
	return relic_precursor_materials_list
end

-- Utility functions to return base dirs for commmon entities used in this script
function getPrecursorItemsBaseDir()
	return "mods/ArcaneReliquary/files/entity_definitions/items/"
end