dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

-- function that randomly buffs projectiles shot by a creature
function buffProjectiles(entity_id)
	
	if(ModSettingGet("ArcaneReliquary.enemy_projectile_buffs") == "OFF") then return end -- doesn't apply projectile buffs if related setting is turned off
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	projectile_buff_chance = Random(1,24)
	if(projectile_buff_chance == 1) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_bleeding.lua", 1, false, "enemy_projectile_shot_bleeding")
	elseif(projectile_buff_chance == 3) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_electrocuting.lua", 1, false, "enemy_projectile_shot_electrocuting")
	elseif(projectile_buff_chance == 5) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_explosive.lua", 1, false, "enemy_projectile_shot_explosive")
	elseif(projectile_buff_chance == 7) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_freezing.lua", 1, false, "enemy_projectile_shot_freezing")
	elseif(projectile_buff_chance == 9) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_damage_boost.lua", 1, false, "enemy_projectile_shot_damage_boost")
	elseif(projectile_buff_chance == 11) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_speed_boost.lua", 1, false, "enemy_projectile_shot_speed_boost")
	elseif(projectile_buff_chance == 13) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_track_and_shoot.lua", 1, false, "enemy_projectile_track_and_shoot")
	elseif(projectile_buff_chance == 15) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_exploding.lua", 1, false, "enemy_projectile_shot_exploding")
	elseif(projectile_buff_chance == 17) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_poly.lua", 1, false, "enemy_projectile_shot_poly")
	elseif(projectile_buff_chance == 19) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_slap.lua", 1, false, "enemy_projectile_shot_slap")
	elseif(projectile_buff_chance == 21) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_drop_wand.lua", 1, false, "enemy_projectile_shot_drop_wand")
	elseif(projectile_buff_chance == 23) then
		addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_paralyse.lua", 1, false, "enemy_projectile_shot_paralyse")
	end
end

-- function that randomly adds defense buffs on creature
function buffDefenses(entity_id)

	if(ModSettingGet("ArcaneReliquary.enemy_defenses_buffs") == "OFF") then return end -- doesn't apply defense buffs if related setting is turned off

	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	defense_buff_chance = Random(1,8)
	if(defense_buff_chance == 1) then
		addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_deflecting_shield.lua", 55, false, "enemy_deflecting_shield")
	elseif(defense_buff_chance == 3) then
		addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_deflecting_freezing_shield.lua", 55, false, "enemy_deflecting_freezing_shield")
	elseif(defense_buff_chance == 5) then
		addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_deflecting_electric_shield.lua", 55, false, "enemy_deflecting_electric_shield")
	elseif(defense_buff_chance == 7) then
		addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_firebomb_shield.lua", 55, false, "enemy_firebomb_shield")
	end
end

-- function that randomly adds basic resistance buffs on the creature
function buffBasicResistances(entity_id)
	
	if(ModSettingGet("ArcaneReliquary.enemy_resistance_buffs") == "OFF") then return end -- doesn't apply damage resistance buffs if related setting is turned off
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	basic_resistance = Random(1,6)
	if(basic_resistance == 1) then
		setBasicDamageMultiplier(entity_id, "fire", 0)
		setBasicDamageMultiplier(entity_id, "explosion", 0)
	elseif(basic_resistance == 3) then
		setBasicDamageMultiplier(entity_id, "electricity", 0)
		setBasicDamageMultiplier(entity_id, "ice", 0)
	elseif(basic_resistance == 5) then
		EntitySetDamageFromMaterial( entity_id, "acid", 0 )
		EntitySetDamageFromMaterial( entity_id, "poison", 0 )
		EntitySetDamageFromMaterial( entity_id, "blood_cold_vapour", 0 )
		EntitySetDamageFromMaterial( entity_id, "lava", 0 )
		EntitySetDamageFromMaterial( entity_id, "radioactive_gas", 0 )
	end
end

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local enemy_can_shoot = enemyRangedAttacksEnabled(entity_id)
local enemy_can_fly = enemyFlightEnabled(entity_id)

local buff_chance = 0

local odds = tonumber(ModSettingGet("ArcaneReliquary.enemy_buff_chance")) -- obtain buff eligibility odds from settings.lua file

local elligible_for_buff = Random(1,odds)
local buff_applied = false
if(elligible_for_buff == 1) then

	if(enemy_can_shoot) then
		buff_chance = Random(1,3)
		
		if(buff_chance == 1) then
			buff_applied = true
			-- health, firerate and movement buffs
			addBuffVisualIndicator(entity_id, "spark_red")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyFirerateBuff(entity_id, Random(5,10))
			if(not enemy_can_fly) then
				enemyApplyMovementBuff(entity_id, Random(4,8))
			end
			-- chance for projectiles buff
			buffProjectiles(entity_id)
			
		elseif(buff_chance == 2) then
			buff_applied = true
			-- health, more projectiles and movement buffs
			addBuffVisualIndicator(entity_id, "spark_red")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyMoreProjectilesBuff(entity_id, 3)
			if(not enemy_can_fly) then
				enemyApplyMovementBuff(entity_id, Random(4,8))
			end
			-- chance for projectiles buff
			buffProjectiles(entity_id)
		elseif(buff_chance == 3) then
			buff_applied = true
			-- firerate and more projectiles buffs
			addBuffVisualIndicator(entity_id, "spark_yellow")
			enemyApplyFirerateBuff(entity_id, Random(5,10))
			enemyApplyMoreProjectilesBuff(entity_id, 2)
			-- chance for projectiles buff
			buffProjectiles(entity_id)
		end
		
	else
		buff_chance = Random(1,5)
		
		if(buff_chance == 1) then
			buff_applied = true
			-- health and melee damage buffs
			addBuffVisualIndicator(entity_id, "spark_green")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyMeleeDamageBuff(entity_id, Random(3,6))

		elseif(buff_chance == 2) then
			buff_applied = true
			-- health and ranged attack buffs
			addBuffVisualIndicator(entity_id, "spark_green")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyRangedAttackBuff(entity_id)
			-- chance for projectiles buff
			buffProjectiles(entity_id)
			
		elseif(buff_chance == 3) then
			buff_applied = true
			-- health and movement buffs
			addBuffVisualIndicator(entity_id, "spark_red")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			if(not enemy_can_fly) then
				enemyApplyMovementBuff(entity_id, Random(4,8))
			end
		elseif(buff_chance == 4) then
			buff_applied = true
			-- health, ranged attack and movement buffs
			addBuffVisualIndicator(entity_id, "spark_blue")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyRangedAttackBuff(entity_id)
			if(not enemy_can_fly) then
				enemyApplyMovementBuff(entity_id, Random(4,8))
			end
			-- chance for projectiles buff
			buffProjectiles(entity_id)
		elseif(buff_chance == 5) then
			buff_applied = true
			-- health, melee damage and movement buffs
			addBuffVisualIndicator(entity_id, "spark_teal")
			enemyApplyHealthBuff(entity_id, Random(6,12))
			enemyApplyMeleeDamageBuff(entity_id, Random(3,6))
			if(not enemy_can_fly) then
				enemyApplyMovementBuff(entity_id, Random(4,8))
			end
		end
	end
end

-- if any buff was applied, adds callback for guaranteed chest drop on death, as well as some extra buffs not related to health boost, melee damage boost, movement boost or projectile buffs
if(buff_applied) then
	buffDefenses(entity_id) -- adds chance for extra defense buff
	buffBasicResistances(entity_id) -- adds chance for basic resistances buff
	addNewSimplifiedInternalVariable(entity_id, "relic_chest_buff") -- tags buffed enemy so that other scripts will have access to this info
	-- adds guaranteed relic chest drop
	addNewLuaCallback(entity_id, "on_death", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_death_guaranteed_chest_drop.lua", 1, true, "enemy_death_guaranteed_chest_drop")
	addBuffIcon(entity_id, "buff_indicator_regular")
end