dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function interacting( entity_who_interacted, entity_interacted, interactable_name )
	
	local relic_buy_price = 0
	-- if player has discount variable, it is applied on buy price
	if(entityHasSimplifiedInternalVariable(entity_who_interacted, "relic_store_discount")) then
		relic_buy_price = getRelicBuyPrice() / 2
	else
		relic_buy_price = getRelicBuyPrice()
	end
	
	local x, y = EntityGetTransform( entity_interacted )
	-- checks if player can afford it
	if (getPlayerGold() >= relic_buy_price) then
		
		-- determine the best place to spawn the relic based on the player's position 
		local player_x, player_y = EntityGetTransform(entity_who_interacted)
		local item_spawn_offset_x = 0
		if(x >= player_x) then
			item_spawn_offset_x = 25 * -1
		else
			item_spawn_offset_x = 25
		end
		local spawn_coordinate_x = player_x + item_spawn_offset_x
		local spawn_coordinate_y = player_y - 15
		
		-- spawns random relic
		local relic = getRandomRelic()
		EntityLoad(getRelicsBaseDir() .. relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		if(relic.requires_relic ~= nil) then -- if spawned relic requires another relic, spawns it together with main relic
			local required_relic = getRelic(relic.requires_relic)
			EntityLoad(getRelicsBaseDir() .. required_relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		end
		
		-- loads audiovisual feedback
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_store_interact_effect.xml", spawn_coordinate_x, spawn_coordinate_y)
		
		-- deducts gold from player
		addPlayerGold(relic_buy_price * -1)
		
		-- shows message
		message = "You bought " .. relic.ui_name .. " for " .. relic_buy_price .. " gold"
		GamePrint(message)
		GamePrintImportant(message, "", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_store.png")
	else
		-- shows error message when not enough gold
		message = "You need " .. relic_buy_price .. " gold to buy a random relic"
		GamePrint(message)
		GamePrintImportant(message, "", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_error.png")
		-- loads audio feedback
		GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest_bad/create", x, y )
	end
end