dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

-- pool of ranged attack buffs
enemy_buffed_projectiles_pool = {
	{
		name 		= "bleeding",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_bleeding.lua", 1, false, "enemy_projectile_shot_bleeding")
		end,
		icon_name	= "buff_indicator_projectile_bleeding"
	},
	{
		name 		= "electrocuting",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_electrocuting.lua", 1, false, "enemy_projectile_shot_electrocuting")
		end,
		icon_name	= "buff_indicator_projectile_electrocuting"
	},
	{
		name 		= "explosive",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_explosive.lua", 1, false, "enemy_projectile_shot_explosive")
		end,
		icon_name	= "buff_indicator_projectile_explosive"
	},
	{
		name 		= "freezing",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_freezing.lua", 1, false, "enemy_projectile_shot_freezing")
		end,
		icon_name	= "buff_indicator_projectile_freeze"
	},
	{
		name 		= "damage_boost",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_damage_boost.lua", 1, false, "enemy_projectile_shot_damage_boost")
		end,
		icon_name	= "buff_indicator_projectile_damage"
	},
	{
		name 		= "speed_boost",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_speed_boost.lua", 1, false, "enemy_projectile_shot_speed_boost")
		end,
		icon_name	= "buff_indicator_projectile_velocity"
	},
	{
		name 		= "slap",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_slap.lua", 1, false, "enemy_projectile_shot_slap")
		end,
		icon_name	= "buff_indicator_projectile_slap"
	},
	{
		name 		= "melee_damage",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_melee.lua", 1, false, "enemy_projectile_shot_melee")
		end,
		icon_name	= "buff_indicator_projectile_melee"
	},
	{
		name 		= "slice_damage",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_slice.lua", 1, false, "enemy_projectile_shot_slice")
		end,
		icon_name	= "buff_indicator_projectile_slice"
	},
	{
		name 		= "wind",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_wind.lua", 1, false, "enemy_projectile_shot_wind")
		end,
		icon_name	= "buff_indicator_projectile_wind"
	},
	{
		name 		= "wind_heavy",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_wind_heavy.lua", 1, false, "enemy_projectile_shot_wind_heavy")
		end,
		icon_name	= "buff_indicator_projectile_wind_heavy"
	},
	{
		name 		= "destroy_player_projectiles",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_destroy_player_projectiles.lua", 1, false, "enemy_projectile_shot_destroy_player_projectiles")
		end,
		icon_name	= "buff_indicator_projectile_destroy"
	},
	{
		name 		= "redirect_player_projectiles",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_redirect_player_projectiles.lua", 1, false, "enemy_projectile_shot_redirect_player_projectiles")
		end,
		icon_name	= "buff_indicator_projectile_redirect"
	},
}

-- pool of level 4 ranged attack buffs
ultimate_enemy_buffed_projectiles_pool = {
	{
		name 		= "exploding",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_exploding.lua", 1, false, "enemy_projectile_shot_exploding")
		end,
		icon_name	= "buff_indicator_projectile_exploding"
	},
	{
		name 		= "track_and_shoot",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_track_and_shoot.lua", 1, false, "enemy_projectile_track_and_shoot")
		end,
		icon_name	= "buff_indicator_projectile_track"
	},
	{
		name 		= "disarm",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_drop_wand.lua", 1, false, "enemy_projectile_shot_drop_wand")
		end,
		icon_name	= "buff_indicator_projectile_disarm"
	},
	{
		name 		= "paralyse",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_paralyse.lua", 1, false, "enemy_projectile_shot_paralyse")
		end,
		icon_name	= "buff_indicator_projectile_paralyse"
	},
	{
		name 		= "shrapnel",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_shrapnel.lua", 1, false, "enemy_projectile_shot_shrapnel")
		end,
		icon_name	= "buff_indicator_projectile_shrapnel"
	},
	{
		name 		= "thunderbolts",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_thunderbolts.lua", 1, false, "enemy_projectile_shot_thunderbolts")
		end,
		icon_name	= "buff_indicator_projectile_thunderbolts"
	},
	{
		name 		= "slimebolts",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_slimebolts.lua", 1, false, "enemy_projectile_shot_slimebolts")
		end,
		icon_name	= "buff_indicator_projectile_slimebolts"
	},
	{
		name 		= "thunderbolt_target",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_thunderbolt_target.lua", 1, false, "enemy_projectile_shot_thunderbolt_target")
		end,
		icon_name	= "buff_indicator_projectile_thunderbolt_target"
	},
	{
		name 		= "rocket_target",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rocket_target.lua", 1, false, "enemy_projectile_shot_rocket_target")
		end,
		icon_name	= "buff_indicator_projectile_rocket_target"
	},
	{
		name 		= "instakill",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_instakill.lua", 1, false, "enemy_projectile_shot_instakill")
		end,
		icon_name	= "buff_indicator_projectile_instakill"
	},
	{
		name 		= "poly",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_poly.lua", 1, false, "enemy_projectile_shot_poly")
		end,
		icon_name	= "buff_indicator_projectile_poly"
	},
	{
		name 		= "projectile_rotating_shield_electric",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rotating_shield_electric.lua", 1, false, "enemy_projectile_shot_rotating_shield_electric")
		end,
		icon_name	= "buff_indicator_projectile_rotating_shield_electric"
	},
	{
		name 		= "projectile_rotating_shield_burning",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rotating_shield_burning.lua", 1, false, "enemy_projectile_shot_rotating_shield_burning")
		end,
		icon_name	= "buff_indicator_projectile_rotating_shield_burning"
	},
	{
		name 		= "projectile_rotating_shield_freezing",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rotating_shield_freezing.lua", 1, false, "enemy_projectile_shot_rotating_shield_freezing")
		end,
		icon_name	= "buff_indicator_projectile_rotating_shield_freezing"
	},
	{
		name 		= "projectile_rotating_shield_mutating",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rotating_shield_mutating.lua", 1, false, "enemy_projectile_shot_rotating_shield_mutating")
		end,
		icon_name	= "buff_indicator_projectile_rotating_shield_mutating"
	},
	{
		name 		= "projectile_rotating_shield_sawblade",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_projectile_shot_rotating_shield_sawblade.lua", 1, false, "enemy_projectile_shot_rotating_shield_sawblade")
		end,
		icon_name	= "buff_indicator_projectile_rotating_shield_sawblade"
	},
}

-- pool of defense buffs
enemy_defenses_pool = {
	{
		name 		= "shield_regular",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_shield").path )
		end,
		icon_name	= "buff_indicator_shield_regular"
	},
	{
		name 		= "shield_electric",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_electric_shield").path )
		end,
		icon_name	= "buff_indicator_shield_elec"
	},
	{
		name 		= "shield_firebomb",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_firebomb_shield").path )
		end,
		icon_name	= "buff_indicator_shield_firebomb"
	},
	{
		name 		= "shield_freeze",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_freezing_shield").path )
		end,
		icon_name	= "buff_indicator_shield_freeze"
	},
	{
		name 		= "field_damaging",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_damaging_field").path )
		end,
		icon_name	= "buff_indicator_field_damage"
	},
	{
		name 		= "field_burning",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_burning_field").path )
		end,
		icon_name	= "buff_indicator_field_burn"
	},
	{
		name 		= "field_freezing",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_freezing_field").path )
		end,
		icon_name	= "buff_indicator_field_freeze"
	},
	{
		name 		= "field_electrocuting",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_electrocuting_field").path )
		end,
		icon_name	= "buff_indicator_field_electrocute"
	},
	{
		name 		= "field_pulsate",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_pulsating_shield").path )
		end,
		icon_name	= "buff_indicator_field_pulsate"
	},
	{
		name 		= "field_pulsate_life_drain",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_pulsating_shield_life_drain").path )
		end,
		icon_name	= "buff_indicator_field_pulsate_life_drain"
	},
	{
		name 		= "rotating_shield_red",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_red"
	},
	{
		name 		= "rotating_shield_teal",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_change_direction_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_change_direction")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_teal"
	},
	{
		name 		= "rotating_shield_blue",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_blue"
	},
	{
		name 		= "rotating_shield_orange",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_lava_shot_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_lava_shot")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_orange"
	},
	{
		name 		= "rotating_shield_purple",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_poison_shot_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_poison_shot")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_purple"
	},
	{
		name 		= "rotating_shield_green",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_acid_shot_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_acid_shot")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_green"
	},
	{
		name 		= "rotating_shield_grey",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_damage_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_damage")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_grey"
	},
	{
		name 		= "monk_hands",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand", "monk_arm_fx", "player_unit")
		end,
		icon_name	= "buff_indicator_hands"
	},
	{
		name 		= "monk_hands_explosive",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_explosive", "monk_arm_fx_explosive", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_explosive"
	},
	{
		name 		= "monk_hands_acid",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_acid", "monk_arm_fx_acid", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_acid"
	},
	{
		name 		= "monk_hands_water",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_water", "monk_arm_fx_water", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_water"
	},
	{
		name 		= "monk_hands_poly",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_poly", "monk_arm_fx_poly", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_poly"
	},
	{
		name 		= "monk_hands_poison",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_poison", "monk_arm_fx_poison", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_poison"
	},
	{
		name 		= "monk_hands_urine",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_urine", "monk_arm_fx_urine", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_urine"
	},
	{
		name 		= "monk_hands_lava",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_lava", "monk_arm_fx_lava", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_lava"
	},
	{
		name 		= "monk_hands_melee",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_melee", "monk_arm_fx_melee", "player_unit")

			-- adding variables and check script to reload hands
			addNewInternalVariable(entity_id, "hand_entity_name", "value_string", "monk_hand_melee")
			addNewInternalVariable(entity_id, "hand_fx_entity_name", "value_string", "monk_arm_fx_melee")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_hands.lua", 35, false, "enemy_check_hands")
		end,
		icon_name	= "buff_indicator_hands_melee"
	},
	{
		name 		= "monk_hands_power_orb",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_power_orb", "monk_arm_fx_power_orb", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_power_orb"
	},
	{
		name 		= "companion",
		func 		= function (entity_id)
			local default_target_tag = "player_unit"
			local companions_pool = getPoolofCompanions()
			local picked_companion = companions_pool[Random(1,#companions_pool)]
			if(picked_companion == "ankh") then -- if ankh companion was added, includes callback related to it
				addNewLuaCallback(entity_id, "on_damaged", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_damaged_ankh_shoot.lua", 1, false, "enemy_damaged_ankh_shoot")
			end
			if(picked_companion == "interceptor_droid") then -- if interceptor droid was picked, modifies target tag to projectile
				default_target_tag = "projectile"
			end
			local companion_id = attachCompaniontoEntity(entity_id, picked_companion, default_target_tag)
			if(picked_companion == "microrocket_droid") then -- if microrocket droid was picked, modifies it to the player seeking version of rocket projectile shot by it
				setInternalVariableValue(companion_id, "projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rocket_tiny_roll_enemy.xml")
			end
		end,
		icon_name	= "buff_indicator_companion"
	},
}

-- pool of level 4 defense buffs
ultimate_enemy_defenses_pool = {
	--[[
	{
		name 		= "rotating_shield_pink",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_mutate_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_mutate")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_pink"
	},
	]]
	
	{
		name 		= "rotating_shield_disc_bullets",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_disc_bullet_big.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_disk_bullet")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_disc_bullets"
	},
	
	{
		name 		= "rotating_shield_disc_bullets_small",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_disc_bullet_medium.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_disk_bullet_medium")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_disc_bullets_small"
	},
	{
		name 		= "rotating_shield_white_melee",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_melee_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_melee")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_white_melee"
	},
	{
		name 		= "rotating_shield_radioactive",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_radioactive_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_radioactive")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_radioactive"
	},
	{
		name 		= "rotating_shield_water",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_water_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_water")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_water"
	},
	{
		name 		= "rotating_shield_nuclear",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_nuclear_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_nuclear")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
			
			addNewLuaCallback(entity_id, "on_damaged", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_damaged_rotating_orb_purple_shoot.lua", 1, false, "enemy_damaged_rotating_orb_purple_shoot")
		end,
		icon_name	= "buff_indicator_rotating_shield_nuclear"
	},
	{
		name 		= "rotating_shield_acid",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_acid_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_acid")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_acid"
	},
	{
		name 		= "rotating_shield_poly",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_poly_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_poly")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_poly"
	},
	{
		name 		= "rotating_shield_blood",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_blood_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_blood")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_blood"
	},
	{
		name 		= "rotating_shield_blizzard",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_blizzard_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_blizzard")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_blizzard"
	},
	{
		name 		= "rotating_shield_solar",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_solar_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_solar")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_solar"
	},
	{
		name 		= "rotating_shield_yellow_retaliate",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_explosive_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_explosive")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
			
			addNewLuaCallback(entity_id, "on_damaged", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_damaged_rotating_orb_yellow_shoot.lua", 1, false, "enemy_damaged_rotating_orb_yellow_shoot")
		end,
		icon_name	= "buff_indicator_rotating_shield_yellow_retaliate"
	},
	{
		name 		= "rotating_shield_thunder",
		func 		= function (entity_id)
			addNewInternalVariable(entity_id, "rotating_projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rotating_shield_target_thunder_part.xml")
			addNewInternalVariable(entity_id, "rotating_projectile_name", "value_string", "rotating_shield_projectile_target_thunder")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_rotating_shield.lua", 35, false, "enemy_check_rotating_shield")
		end,
		icon_name	= "buff_indicator_rotating_shield_thunder"
	},
	{
		name 		= "shield_fireballs_poly",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_mutating_shield").path )
		end,
		icon_name	= "buff_indicator_shield_poly"
	},
	
	{
		name 		= "shield_fireballs_radioactive",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_fireball_radioactive_shield").path )
		end,
		icon_name	= "buff_indicator_shield_fireball_radioactive"
	},
	{
		name 		= "shield_iceballs",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_iceball_shield").path )
		end,
		icon_name	= "buff_indicator_shield_iceball"
	},
	{
		name 		= "shield_thunder",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_thunder_shield").path )
		end,
		icon_name	= "buff_indicator_shield_thunder"
	},
	{
		name 		= "shield_thunder_red",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_deflecting_thunder_red_shield").path )
		end,
		icon_name	= "buff_indicator_shield_thunder_red"
	},
	
	{
		name 		= "shield_fireballs",
		func 		= function (entity_id)
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_fireball_shield").path )
		end,
		icon_name	= "buff_indicator_shield_fireball"
	},
	{
		name 		= "reflect_damage",
		func 		= function (entity_id)
			addNewLuaCallback(entity_id, "on_damaged", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_damaged_reflect_damage.lua", 1, false, "enemy_damaged_reflect_damage")
		end,
		icon_name	= "buff_indicator_defense_reflect_damage"
	},
	{
		name 		= "monk_hands_high_explosive",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_high_explosive", "monk_arm_fx_high_explosive", "mortal")
		end,
		icon_name	= "buff_indicator_hands_high_explosive"
	},
	{
		name 		= "monk_hands_blood",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_blood", "monk_arm_fx_blood", "mortal")
		end,
		icon_name	= "buff_indicator_hands_blood"
	},
	{
		name 		= "monk_hands_slap",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_slap", "monk_arm_fx_slap", "mortal")
		end,
		icon_name	= "buff_indicator_hands_slap"
	},
	{
		name 		= "monk_hands_wind",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_wind", "monk_arm_fx_wind", "mortal")
		end,
		icon_name	= "buff_indicator_hands_wind"
	},
	
	{
		name 		= "monk_hands_white_star",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_white_star", "monk_arm_fx_white_star", "mortal")
		end,
		icon_name	= "buff_indicator_hands_white_star"
	},
	{
		name 		= "monk_hands_power_orb_nuclear",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_power_orb_nuclear", "monk_arm_fx_power_orb_nuclear", "player_unit")
		end,
		icon_name	= "buff_indicator_hands_power_orb_nuclear"
	},
	{
		name 		= "monk_hands_overheated",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_overheated", "monk_arm_fx_overheated", "player_unit")
			
			-- adding variables and check script to reload hands
			addNewInternalVariable(entity_id, "hand_entity_name", "value_string", "monk_hand_overheated")
			addNewInternalVariable(entity_id, "hand_fx_entity_name", "value_string", "monk_arm_fx_overheated")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_hands.lua", 35, false, "enemy_check_hands")
		end,
		icon_name	= "buff_indicator_hands_overheated"
	},
	{
		name 		= "monk_hands_frozen",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_frozen", "monk_arm_fx_frozen", "player_unit")
			
			-- adding variables and check script to reload hands
			addNewInternalVariable(entity_id, "hand_entity_name", "value_string", "monk_hand_frozen")
			addNewInternalVariable(entity_id, "hand_fx_entity_name", "value_string", "monk_arm_fx_frozen")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_hands.lua", 35, false, "enemy_check_hands")
		end,
		icon_name	= "buff_indicator_hands_frozen"
	},
	{
		name 		= "monk_hands_charged",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_charged", "monk_arm_fx_charged", "player_unit")
			
			-- adding variables and check script to reload hands
			addNewInternalVariable(entity_id, "hand_entity_name", "value_string", "monk_hand_charged")
			addNewInternalVariable(entity_id, "hand_fx_entity_name", "value_string", "monk_arm_fx_charged")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_hands.lua", 35, false, "enemy_check_hands")
		end,
		icon_name	= "buff_indicator_hands_charged"
	},
	{
		name 		= "monk_hands_nuclear",
		func 		= function (entity_id)
			attachMonkHandstoEntity(entity_id, "monk_hand_nuclear", "monk_arm_fx_nuclear", "player_unit")
			
			-- adding variables and check script to reload hands
			addNewInternalVariable(entity_id, "hand_entity_name", "value_string", "monk_hand_nuclear")
			addNewInternalVariable(entity_id, "hand_fx_entity_name", "value_string", "monk_arm_fx_nuclear")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_check_hands.lua", 35, false, "enemy_check_hands")
		end,
		icon_name	= "buff_indicator_hands_nuclear"
	},
	{
		name 		= "companion_plus",
		func 		= function (entity_id)
			local how_many = Random(3,5)
			local companions_pool = getPoolofCompanions()
			for i=1,how_many do
				local default_target_tag = "player_unit"
				local picked_companion = companions_pool[Random(1,#companions_pool)]
				local companion_id = attachCompaniontoEntity(entity_id, picked_companion, "player_unit")
				
				if(picked_companion == "interceptor_droid") then -- if interceptor droid was picked, modifies target tag to projectile
					default_target_tag = "projectile"
				end
				if(picked_companion == "microrocket_droid") then -- if microrocket droid was picked, modifies it to the player seeking version of rocket projectile shot by it
					setInternalVariableValue(companion_id, "projectile_definition", "value_string", "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/rocket_tiny_roll_enemy.xml")
				end
				
				local companion_id = attachCompaniontoEntity(entity_id, picked_companion, default_target_tag)
			end
			if(entityHasCompanion("ankh")) then -- if ankh companion was added, includes callback related to it
				addNewLuaCallback(entity_id, "on_damaged", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_damaged_ankh_shoot.lua", 1, false, "enemy_damaged_ankh_shoot")
			end
			
		end,
		icon_name	= "buff_indicator_companion_plus"
	},
}

-- pool of resistance buffs
enemy_resistances_pool = {
	{
		name 		= "fire_and_explosions",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "fire", 0)
			setBasicDamageMultiplier(entity_id, "explosion", 0)
		end,
		icon_name	= "buff_indicator_resistance_fire_explosion"
	},
	{
		name 		= "ice_and_electricity",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "electricity", 0)
			setBasicDamageMultiplier(entity_id, "ice", 0)
		end,
		icon_name	= "buff_indicator_resistance_ice_elec"
	},
	{
		name 		= "melee_and_slice",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "melee", 0)
			setBasicDamageMultiplier(entity_id, "slice", 0)
		end,
		icon_name	= "buff_indicator_resistance_melee_slice"
	},
	{
		name 		= "physics_impact",
		func 		= function (entity_id)
			creaturePhysicsObjectsDamage(entity_id, false)
		end,
		icon_name	= "buff_indicator_resistance_physics_impact"
	},
	{
		name 		= "damaging_materials",
		func 		= function (entity_id)
			EntitySetDamageFromMaterial( entity_id, "acid", 0 )
			EntitySetDamageFromMaterial( entity_id, "poison", 0 )
			EntitySetDamageFromMaterial( entity_id, "blood_cold_vapour", 0 )
			EntitySetDamageFromMaterial( entity_id, "blood_cold", 0 )
			EntitySetDamageFromMaterial( entity_id, "lava", 0 )
			EntitySetDamageFromMaterial( entity_id, "radioactive_gas", 0 )
		end,
		icon_name	= "buff_indicator_resistance_materials"
	},
}

-- pool of level 4 resistance buffs
ultimate_enemy_resistances_pool = {
	
	{
		name 		= "physics_impact_elemental_damage",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "fire", 0)
			setBasicDamageMultiplier(entity_id, "electricity", 0)
			setBasicDamageMultiplier(entity_id, "ice", 0)
			creaturePhysicsObjectsDamage(entity_id, false)
		end,
		icon_name	= "buff_indicator_resistance_physics_impact_elemental"
	},
	{
		name 		= "damaging_materials_and_fire",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "fire", 0)
			EntitySetDamageFromMaterial( entity_id, "acid", 0 )
			EntitySetDamageFromMaterial( entity_id, "poison", 0 )
			EntitySetDamageFromMaterial( entity_id, "blood_cold_vapour", 0 )
			EntitySetDamageFromMaterial( entity_id, "blood_cold", 0 )
			EntitySetDamageFromMaterial( entity_id, "lava", 0 )
			EntitySetDamageFromMaterial( entity_id, "radioactive_gas", 0 )
		end,
		icon_name	= "buff_indicator_resistance_fire_materials"
	},
	
	{
		name 		= "universal_projectile_impact",
		func 		= function (entity_id)
			setBasicDamageMultiplier(entity_id, "projectile", 0)
			setBasicDamageMultiplier(entity_id, "explosion", 0)
			setBasicDamageMultiplier(entity_id, "melee", 0)
			setBasicDamageMultiplier(entity_id, "slice", 0)
		end,
		icon_name	= "buff_indicator_resistance_universal_projectile_impact"
	},
	{
		name 		= "poly",
		func 		= function (entity_id)
			local game_effect_comp_id, game_effect_entity_id = GetGameEffectLoadTo( entity_id, "PROTECTION_POLYMORPH", true )
			if game_effect_comp_id ~= nil then
				ComponentSetValue2( game_effect_comp_id, "frames", -1)
			end
		end,
		icon_name	= "buff_indicator_resistance_poly"
	},
}

-- pool of regular buffs
basic_enemy_buffs_pool = {
	{
		name 		= "more_hp",
		enemy_type 	= "shooter,melee,flying",
		func 		= function (entity_id)
			enemyApplyHealthBuff(entity_id, Random(3,5))
		end,
		icon_name	= "buff_indicator_more_hp"
	},
	{
		name 		= "firerate",
		enemy_type 	= "shooter,flying",
		func 		= function (entity_id)
			enemyApplyFirerateBuff(entity_id, Random(5,10))
		end,
		icon_name	= "buff_indicator_firerate"
	},
	{
		name 		= "movement",
		enemy_type 	= "shooter,melee",
		func 		= function (entity_id)
			enemyApplyMovementBuff(entity_id, Random(4,8))
		end,
		icon_name	= "buff_indicator_movement"
	},
	{
		name 		= "more_projectiles",
		enemy_type 	= "shooter,flying",
		func 		= function (entity_id)
			enemyApplyMoreProjectilesBuff(entity_id, Random(2,3))
		end,
		icon_name	= "buff_indicator_more_projectiles"
	},
	{
		name 		= "melee",
		enemy_type 	= "shooter,melee,flying",
		func 		= function (entity_id)
			enemyApplyMeleeDamageBuff(entity_id, Random(3,6))
		end,
		icon_name	= "buff_indicator_melee"
	},
	{
		name 		= "ranged_attack",
		enemy_type 	= "melee,flying",
		func 		= function (entity_id)
			enemyApplyRangedAttackBuff(entity_id)
		end,
		icon_name	= "buff_indicator_nonshooter_ranged"
	},
}

-- list of buffs applied
local buffs_applied = {}

-- buff icon offsets
local icon_farthest_right = 29
local icon_middle_right = 21
local icon_middle_closest_right = 12
local icon_middle = 3
local icon_middle_closest_left = -6
local icon_middle_left = -15
local icon_farthest_left = -24

-- function that randomly buffs projectiles shot by a creature
function buffProjectiles(entity_id, level_4_buff)
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	local buff = nil
	if(level_4_buff) then
		buff = ultimate_enemy_buffed_projectiles_pool[Random(1,#ultimate_enemy_buffed_projectiles_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	else
		buff = enemy_buffed_projectiles_pool[Random(1,#enemy_buffed_projectiles_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	end
	
	return buff.icon_name
end

-- function that randomly adds defense buffs on creature
function buffDefenses(entity_id, level_4_buff)
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	local buff = nil
	if(level_4_buff) then
		buff = ultimate_enemy_defenses_pool[Random(1,#ultimate_enemy_defenses_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	else
		buff = enemy_defenses_pool[Random(1,#enemy_defenses_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	end
	
	return buff.icon_name
end

-- function that randomly adds basic resistance buffs on the creature
function buffBasicResistances(entity_id, level_4_buff)
	
	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	local buff = nil
	if(level_4_buff) then
		buff = ultimate_enemy_resistances_pool[Random(1,#ultimate_enemy_resistances_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	else
		buff = enemy_resistances_pool[Random(1,#enemy_resistances_pool)]
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	end
	
	return buff.icon_name
end

-- function that randomly selects a basic buff from basic_enemy_buffs_pool then applies it on the creature
function applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot)
	
	local elligible_buffs = nil
	if(enemy_can_shoot) then
		elligible_buffs = findBuffsByEnemyType("shooter")
	else
		elligible_buffs = findBuffsByEnemyType("melee")
	end

	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
	local buff = elligible_buffs[Random(1,#elligible_buffs)]
	
	if(not (checkAppliedBuff(buff.name) and buff.name == "ranged_attack")) then -- ranged_attack is the only basic buff that doesn't make sense to be duplicated, so this block is used to prevent it
		buff.func(entity_id)
		registerBuff(entity_id, buff.name) -- registers buff applied
	else
		return applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot) -- calls function again if ranged_attack buff has already been applied
	end
	
	table.insert(buffs_applied, buff.name)
	
	-- returns buff icon according to the one obtained randomly
	return buff.icon_name
end

-- function to obtain basic buffs that are compatible with flying enemies
function findBuffsByEnemyType(enemy_type)
	
	local elligible_buffs = {}
	
	for i,basic_buff in ipairs(basic_enemy_buffs_pool) do 
		if(string.find(basic_buff.enemy_type, enemy_type)) then
			table.insert(elligible_buffs, basic_buff)
		end	
	end
	
	return elligible_buffs
end

-- function to check for duplicated buffs
function checkAppliedBuff(name)
	local flag = false
	for i,applied_buff in ipairs(buffs_applied) do
		if(applied_buff == name) then
			flag = true
		end
	end
	return flag
end

-- function that registers buffs added to the enemy as internal variables
function registerBuff(entity_id, buff_name)
	addNewInternalVariable(entity_id, "applied_buff", "value_string", buff_name)
end

local entity_id = GetUpdatedEntityID()

-- checks to exclude some enemies from the buff mechanic
if(entityHasSimplifiedInternalVariable(entity_id, "minion")) then return end -- check to prevent buffs from being applied on player spawned minions
if(entityHasSimplifiedInternalVariable(entity_id, "enemy_spawn")) then return end -- check to prevent enemies spawned by other enemies from receiving buffs
if(EntityHasTag(entity_id, "wand_ghost")) then return end -- check to prevent summomed wands from becoming buffed
if(EntityHasTag(entity_id, "drone_friendly") or EntityHasTag(entity_id, "drone_healing")) then return end -- check to prevent buffs on Evaisa's drones
if(EntityHasTag(entity_id, "polymorphed")) then return end -- check to prevent creatures spawned as a result of the poly effect from receiving buffs
if(EntityHasTag(entity_id, "plague_rat")) then return end -- check to prevent plague rats spawned with perks from receiving buffs
if(EntityHasTag(entity_id, "perk_fungus_tiny")) then return end -- check to prevent fungal creatures spawned with perks from receiving buffs
if(isCreatureBoss(entity_id)) then return end -- check to prevent bosses from receiving buffs

-- obtains creature's coordinates and generates random seed
local x, y = EntityGetTransform(entity_id)
SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

-- then, checks whether No Buffs Mode is activated
-- if so, enemy receives no buffs, but is set to drop a chest on death
if(ModSettingGet("ArcaneReliquary.no_buffs_mode") == "ENABLED") then
	
	if(entityHasSimplifiedInternalVariable(entity_id, "coxas_item_drop_tag")) then return end -- if creature is already carrying a special item, skips everything below
	
	local odds = tonumber(ModSettingGet("ArcaneReliquary.enemy_buff_chance")) -- eligibility odds obtained from settings.lua file
	local elligible = Random(1,odds) -- item drop chance setting is used to control how often enemies will carry chests
	
	if(elligible == 1) then
		addBuffIcon(entity_id, "item_indicator_chest", icon_middle)
		addNewSimplifiedInternalVariable(entity_id, "coxas_item_drop_tag") -- tags enemy generically to allow other mods to detect this
		addNewSimplifiedInternalVariable(entity_id, "no_buff_chest_drop_chance") -- tags enemy so that other scripts will have access to this info
		-- adds guaranteed no buff chest drop callback
		addNewLuaCallback(entity_id, "on_death", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_death_guaranteed_chest_drop_no_buff.lua", 1, true, "enemy_death_guaranteed_chest_drop_no_buff")
		-- tags creature so no other item drops are added
		addNewSimplifiedInternalVariable(entity_id, "relic_chest_buff")
	end
	
	--[[
	local chest_replacement_odds = 10
	if(Random(1,chest_replacement_odds) == 1) then
		GamePrint("A relic chest appeared somewhere...")
		local pseudo_buff_level = Random(1,4)
		EntityKill(entity_id)
		local chests_pool = {"relic_chest.xml", "relic_chest_great.xml", "relic_chest_chaotic.xml"}
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/" .. chests_pool[Random(1,#chests_pool)], x, y )
	end
	]]
	return
end


-- flags for shooting or flying enemies
local enemy_can_shoot = enemyRangedAttacksEnabled(entity_id)
local enemy_can_fly = enemyFlightEnabled(entity_id)

local odds = tonumber(ModSettingGet("ArcaneReliquary.enemy_buff_chance")) -- buff eligibility odds obtained from settings.lua file
local max_buff_level = tonumber(ModSettingGet("ArcaneReliquary.max_buff_level")) -- maximum buff level obtained from settings.lua file

local elligible_for_buff = Random(1,odds) -- regulates how often enemies are elligible to receive buffs
local buff_level = 0
if(elligible_for_buff == 1) then -- if an enemy becomes elligible for a buff, it can now receive a random buff level
	
	buff_level = Random(1,max_buff_level) -- this controls the buff level
	local buff_icon_name = ""
	
	-- force a given level to test buffs
	--buff_level = 4
	
	if(buff_level == 1) then -- configures level 1 buff, which includes 1 to 2 basic buffs
		local how_many_buffs = Random(1,2)
		local icon_slots = {icon_middle_closest_right, icon_middle_closest_left}
		for i=1,how_many_buffs do
			buff_icon_name = applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot)
			addBuffIcon(entity_id, buff_icon_name, icon_slots[i])
		end
	elseif(buff_level == 2) then -- configures level 2 buff, which includes 3 to 4 basic buffs
		local how_many_buffs = Random(3,4)
		local icon_slots = {icon_middle_closest_right, icon_middle_closest_left, icon_middle_right, icon_middle_left}
		for i=1,how_many_buffs do
			buff_icon_name = applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot)
			addBuffIcon(entity_id, buff_icon_name, icon_slots[i])
		end
	elseif(buff_level == 3) then -- configures level 3 buff, which includes always 4 buffs and also 1 to 2 advanced buffs
		-- applies basic buffs first
		local how_many_buffs = 4
		local icon_slots = {icon_middle_closest_right, icon_middle_closest_left, icon_middle_right, icon_middle_left}
		for i=1,how_many_buffs do
			buff_icon_name = applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot)
			addBuffIcon(entity_id, buff_icon_name, icon_slots[i])
		end
		
		-- then applies advanced buffs
		how_many_buffs = Random(1,2) -- up to 2 advanced buffs maximum
		local icon_slots_advanced_buffs = {icon_farthest_right, icon_farthest_left}
		local advanced_buff_types = nil
		if(enemy_can_shoot or checkAppliedBuff("ranged_attack")) then
			advanced_buff_types = {"defense", "projectile", "resistance"}
		else
			advanced_buff_types = {"defense", "resistance"} -- if enemy is unable to shoot or didn't receive a ranged attack buff, then projectile buff is excluded from the list
		end
		-- initializes advanced_buffs_applied table
		local advanced_buffs_applied = {}
		for i=1,how_many_buffs do
			local table_index = Random(1,#advanced_buff_types)
			local advanced_buff_type_picked = advanced_buff_types[table_index]
			table.remove(advanced_buff_types, table_index)
			if(advanced_buff_type_picked == "defense") then -- applies defense buff
				buff_icon_name = buffDefenses(entity_id, false)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			elseif(advanced_buff_type_picked == "projectile") then -- applies projectile buff if enemy is shooter or if it received a ranged attack basic buff
				buff_icon_name = buffProjectiles(entity_id, false)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			elseif(advanced_buff_type_picked == "resistance") then -- applies resistance buff
				buff_icon_name = buffBasicResistances(entity_id, false)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			end
		end
	elseif(buff_level == 4) then -- configures level 3 buff, which includes always 4 buffs and also 2 ultimate buffs
		-- applies basic buffs first
		local how_many_buffs = 4
		local icon_slots = {icon_middle_closest_right, icon_middle_closest_left, icon_middle_right, icon_middle_left}
		for i=1,how_many_buffs do
			buff_icon_name = applyBasicBuff(entity_id, enemy_can_fly, enemy_can_shoot)
			addBuffIcon(entity_id, buff_icon_name, icon_slots[i])
		end
		
		-- then applies ultimate buffs
		how_many_buffs = 2
		local icon_slots_advanced_buffs = {icon_farthest_right, icon_farthest_left}
		local advanced_buff_types = nil
		if(enemy_can_shoot or checkAppliedBuff("ranged_attack")) then
			advanced_buff_types = {"defense", "projectile", "resistance"}
		else
			advanced_buff_types = {"defense", "resistance"} -- if enemy is unable to shoot or didn't receive a ranged attack buff, then projectile buff is excluded from the list
		end
		-- initializes advanced_buffs_applied table
		local advanced_buffs_applied = {}
		for i=1,how_many_buffs do
			local table_index = Random(1,#advanced_buff_types)
			local advanced_buff_type_picked = advanced_buff_types[table_index]
			table.remove(advanced_buff_types, table_index)
			if(advanced_buff_type_picked == "defense") then -- applies defense buff
				buff_icon_name = buffDefenses(entity_id, true)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			elseif(advanced_buff_type_picked == "resistance") then -- applies resistance buff
				buff_icon_name = buffBasicResistances(entity_id, true)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			elseif(advanced_buff_type_picked == "projectile") then -- applies projectile buff if enemy is shooter or if it received a ranged attack basic buff
				buff_icon_name = buffProjectiles(entity_id, true)
				addBuffIcon(entity_id, buff_icon_name, icon_slots_advanced_buffs[i])
			end
		end
	end
	
end

-- if any buff was applied, tags enemy and adds chest drop callback
if(buff_level > 0) then
	addNewSimplifiedInternalVariable(entity_id, "relic_chest_buff") -- tags buffed enemy so that other scripts will have access to this info
	addNewSimplifiedInternalVariable(entity_id, "buff_level_" .. buff_level) -- tags buffed enemy with its buff level
	
	-- adds guaranteed relic chest drop
	addNewLuaCallback(entity_id, "on_death", "mods/ArcaneReliquary/files/scripts/other_listeners/enemy_death_guaranteed_chest_drop.lua", 1, true, "enemy_death_guaranteed_chest_drop")
	
	-- adds main icon according to the level of the applied buff
	addBuffIcon(entity_id, "buff_indicator_level_" .. buff_level, icon_middle)
	addNewSimplifiedInternalVariable(entity_id, "coxas_item_drop_tag") -- tags enemy generically to allow other mods to detect this
	
	EntityAddTag(entity_id, "gkbrkn_no_champion") -- compatibility tag added for Goki's Things
end