dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

function interacting( entity_who_interacted, entity_interacted, interactable_name )
	
	-- obtains available plays from machine
	local plays = getInternalVariableValue(entity_interacted, "plays", "value_int")
	
	local x, y = EntityGetTransform( entity_interacted )
	-- checks if are there plays left
	if (plays >= 1) then
		
		-- determine the best place to spawn the relic based on the player's position 
		local player_x, player_y = EntityGetTransform(entity_who_interacted)
		local item_spawn_offset_x = 0
		if(x >= player_x) then
			item_spawn_offset_x = 25 * -1
		else
			item_spawn_offset_x = 25
		end
		local spawn_coordinate_x = player_x + item_spawn_offset_x
		local spawn_coordinate_y = player_y - 15
		
		-- spawns random relic
		local relic = getRandomRelic()
		EntityLoad(getRelicsBaseDir() .. relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		if(relic.requires_relic ~= nil) then -- if spawned relic requires another relic, spawns it together with main relic
			local required_relic = getRelic(relic.requires_relic)
			EntityLoad(getRelicsBaseDir() .. required_relic.name .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		end
		
		-- loads audiovisual feedback
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/relic_prize_machine_interact_effect.xml", spawn_coordinate_x, spawn_coordinate_y)
		
		-- deducts plays from machine
		local new_plays = plays - 1
		setInternalVariableValue(entity_interacted, "plays", "value_int", new_plays)
		
		-- shows message
		message = "Random relic dispensed"
		message_extra = new_plays .. " plays left in this Relic Prize Machine"
		GamePrint(message .. ", " .. message_extra)
		GamePrintImportant(message, message_extra, "mods/ArcaneReliquary/files/other_gfx/custom_decoration_store.png")
	else
		-- shows error message when not enough gold
		message = "No plays left in this Relic Prize Machine"
		GamePrint(message)
		GamePrintImportant(message, "Deposit Relic Prize Chips on it to get more plays", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_error.png")
		-- loads audio feedback
		GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest_bad/create", x, y )
	end
end