dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

function item_pickup( entity_item, entity_who_picked, item_name )
	
	local pos_x, pos_y = EntityGetTransform( entity_item )
	
	SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_item )
	
	local nugget_name = EntityGetName(entity_item)
	local penalty_applied = false
	if(nugget_name == "riskrewardnugget_pink") then
		-- bonus
		addPlayerHealth(80, false)
		-- penalty
		if(Random(1,2) == 1) then
			LoadGameEffectEntityTo( entity_who_picked, getCustomEffect("effect_material_spit_poly").path )
			penalty_applied = true
		end
	elseif(nugget_name == "riskrewardnugget_orange") then
		-- bonus
		addPlayerGold(600)
		-- penalty
		if(Random(1,2) == 1) then
			LoadGameEffectEntityTo( entity_who_picked, getCustomEffect("effect_material_spit_lava").path )
			penalty_applied = true
		end
	elseif(nugget_name == "riskrewardnugget_purple") then
		-- bonus
		addPlayerHealth(40, false)
		addPlayerGold(300)
		-- penalty
		if(Random(1,2) == 1) then
			LoadGameEffectEntityTo( entity_who_picked, getCustomEffect("effect_material_spit_poison").path )
			penalty_applied = true
		end
	elseif(nugget_name == "riskrewardnugget_lime") then
		-- bonus
		addPlayerHealth(120, false)
		-- penalty
		if(Random(1,2) == 1) then
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/load_on_explosion/explosion_sequence_nuclear.xml", pos_x, pos_y)
			penalty_applied = true
		end
	elseif(nugget_name == "riskrewardnugget_gray") then
		-- bonus
		addPlayerGold(2000)
		-- penalty
		LoadGameEffectEntityTo( entity_who_picked, getCustomEffect("effect_spawn_object_bomb").path )
		penalty_applied = true
	elseif(nugget_name == "riskrewardnugget_red") then
		-- bonus
		addPlayerHealth(25, true)
		-- penalty
		if(Random(1,2) == 1) then
			LoadGameEffectEntityTo( entity_who_picked, getCustomEffect("effect_bleeding_heavy").path )
			penalty_applied = true
		end
	end
	
	if(penalty_applied) then
		GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/chest_bad/create", pos_x, pos_y )
	else
		GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/spell_refresh/create", pos_x, pos_y )
	end
	
	shoot_projectile( entity_item, "mods/ArcaneReliquary/files/entity_definitions/others/healingnugget_pickup.xml", pos_x, pos_y, 0, 0 )
	EntityKill(entity_item)
end