dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()

-- obtains tick number
local ticks = getInternalVariableValue(entity_id, "ticks", "value_int")
ticks = ticks + 1
setInternalVariableValue(entity_id, "ticks", "value_int", ticks)

local emitterMaterial = ""

-- tick logic is as follows:
-- 1 2 3 4 5 6 7 8 9 10 11 12
-- *   *   *   *   *    *
-- tick indicator turns on on odd tick numbers and turns off on even numbers
-- until tick 8 the indicator emits yellow particles, from 9 onwards it switches to red particles indicating the mine is about to explode

if(ticks < 9) then
	emitterMaterial = "spark_yellow"
else
	emitterMaterial = "spark_red"
end

if(not (ticks % 2 == 0)) then
	local x, y = EntityGetTransform(entity_id)
	GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
	
	local pec_id = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
		emitted_material_name=emitterMaterial,
		lifetime_min=0.3,
		lifetime_max=0.4,
		count_min=10,
		count_max=15,
		render_on_grid=true,
		fade_based_on_lifetime=true,
		cosmetic_force_create=false,
		airflow_force=0.5,
		airflow_time=0.5,
		airflow_scale=0.15,
		emission_interval_min_frames=1,
		emission_interval_max_frames=1,
		emit_cosmetic_particles=true,
		draw_as_long=true,
		x_vel_min=-1,
		x_vel_max=1,
		y_vel_min=-1,
		y_vel_max=1,
		is_emitting=true,
		velocity_always_away_from_center=100
	})
	ComponentSetValue2( pec_id, "gravity", 0.0, 0.0 )
	ComponentSetValue2( pec_id, "area_circle_radius", 10, 10)
	
	ComponentAddTag( pec_id, "tick_emitter" )

	local lc_id = EntityAddComponent2(entity_id, "LightComponent", {
		radius=150,
		r=255,
		g=0,
		b=0
	})
	
	ComponentAddTag( lc_id, "tick_light" )
else
	local components = EntityGetComponent( entity_id, "ParticleEmitterComponent" )
	if ( components ~= nil ) then
		for key,comp_id in pairs(components) do 
			if(ComponentHasTag(comp_id, "tick_emitter")) then
				EntityRemoveComponent(entity_id, comp_id)
				break
			end
		end
	end
	
	components = EntityGetComponent( entity_id, "LightComponent" )
	if ( components ~= nil ) then
		for key,comp_id in pairs(components) do 
			if(ComponentHasTag(comp_id, "tick_light")) then
				EntityRemoveComponent(entity_id, comp_id)
				break
			end
		end
	end
end

if(ticks == 12) then
	EntityKill(entity_id)
end

