dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

local entity_id = GetUpdatedEntityID()
local relic_name = EntityGetName(entity_id)

-- updates ui text on all components
local relic = getRelic(relic_name)
local simplified_ui_name = relic.ui_name
local descriptive_ui_name = simplified_ui_name .. " - " .. relic.effect_desc

-- if relic is upgradable, adds it to main description
if(relic.is_upgradable) then
	descriptive_ui_name = descriptive_ui_name .. "\n" .. relic.upgrade_effect_desc
else
	descriptive_ui_name = descriptive_ui_name .. "\nThis relic can't be upgraded."
end

local short_ui_name = simplified_ui_name .. " - " .. relic.effect_desc_short

updateRelicUIText(entity_id, simplified_ui_name, descriptive_ui_name, short_ui_name)

-- this is no longer necessary ever since relic entities started using a base entity file
--[[
-- fix to prevent relics from taking damage
local dmc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
EntityRemoveComponent( entity_id, dmc_id)
]]


