dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local relic_to_construct = getInternalVariableValue(entity_id, "relic_to_construct", "value_string")
local relic_to_construct_level = getInternalVariableValue(entity_id, "relic_to_construct_level", "value_int")
local particle_explosion_path = getInternalVariableValue(entity_id, "particle_explosion_path", "value_string")
local constructed_relic = getRelic(relic_to_construct)

-- loads relics
local new_relic_id = EntityLoad(getRelicsBaseDir() .. constructed_relic.name .. ".xml", x, y)
local relic = getRelic(EntityGetName(new_relic_id))
-- if a level was supplied, applies it to new relic constructed
if(relic_to_construct_level > 0 and relic.is_upgradable) then
	setRelicLevel(relic, new_relic_id, relic_to_construct_level)
end

-- adds audiovisual feedback
EntityLoad(particle_explosion_path, x, y)
GamePlaySound( "data/audio/Desktop/explosions.snd", "explosions/magic_grenade_small", x, y )

if(constructed_relic.requires_relic ~= nil) then -- if spawned relic requires another relic it will spawn together with it
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	local required_relic = getRelic(constructed_relic.requires_relic)
	EntityLoad(getRelicsBaseDir() .. required_relic.name .. ".xml", x, y - 5)
end

-- shows messages
message = "You constructed " .. constructed_relic.ui_name .. "!"
GamePrint(message)
GamePrintImportant(message, "", "mods/ArcaneReliquary/files/other_gfx/custom_decoration_relic_construct.png")

