dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local room_name = getInternalVariableValue(entity_id, "room_name", "value_string")

GamePlaySound( "data/audio/Desktop/explosions.snd", "explosions/magic_grenade_small", x, y )

if(room_name == "compact_machine_room") then
	EntityLoad("mods/ArcaneReliquary/files/pixel_scenes/machine_room/machine_room.xml", x, y)
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	local special_machine_chance = Random(1,4)
	if(special_machine_chance == 1) then
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_store.xml", x - 57, y - 110) -- upper left platform
	elseif(special_machine_chance == 2) then
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_prize_machine.xml", x - 57, y - 110) -- upper left platform
	elseif(special_machine_chance == 3) then
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_slot_machine.xml", x - 57, y - 110) -- upper left platform
	elseif(special_machine_chance == 4) then
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_utility_store.xml", x - 57, y - 110) -- upper left platform
	end
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_combine_station.xml", x + 50, y - 110) -- upper right platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_forge.xml", x - 38, y - 55) -- bottom left platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_workbench.xml", x + 52, y - 55) -- bottom right platform
elseif(room_name == "compact_alchemy_room") then
	EntityLoad("mods/ArcaneReliquary/files/pixel_scenes/alchemy_room/alchemy_room.xml", x, y)
	
	-- empty potion flasks
	EntityLoad("data/entities/items/pickup/potion_empty.xml", x, y - 10)
	EntityLoad("data/entities/items/pickup/potion_empty.xml", x - 10, y - 10)
	EntityLoad("data/entities/items/pickup/potion_empty.xml", x + 10, y - 10)
elseif(room_name == "compact_store_room") then
	EntityLoad("mods/ArcaneReliquary/files/pixel_scenes/store_room/store_room.xml", x, y)
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_prize_machine.xml", x - 57, y - 120) -- upper left platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_store.xml", x + 69, y - 120) -- upper right platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_slot_machine.xml", x - 57, y - 65) -- lower left platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_utility_store.xml", x + 69, y - 65) -- lower right platform
elseif(room_name == "compact_recycling_room") then
	EntityLoad("mods/ArcaneReliquary/files/pixel_scenes/recycling_room/recycling_room.xml", x, y)
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_breakdown_station.xml", x - 25, y - 110) -- upper left platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_recycle_station.xml", x + 38, y - 55) -- bottom right platform
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_transmute_station.xml", x - 30, y - 15) -- ground level left
end