dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

local entity_id = GetUpdatedEntityID()

if(isPlayerMoving()) then
	
	local cc_id = EntityGetFirstComponent(entity_id, "ControlsComponent")
	local key_triggered = ComponentGetValueInt( cc_id, "mButtonFrameInteract" ) == GameGetFrameNum()
	
	if(key_triggered) then
		
		local horizontal_dash_boost = 1200
		
		-- gives player velocity boost according to current moving direction
		local dash_triggered = false
		local movement = getPlayerHorizontalMovement()
		if(movement == "right") then
			local vel_x, vel_y = getPlayerVelocities()
			setPlayerVelocities(vel_x + horizontal_dash_boost, vel_y)
			
			-- adds visual effect that lasts for 10 frames
			addSpriteEffect(entity_id, "mods/ArcaneReliquary/files/other_gfx/dash_attack_right.xml", 25, 20, 10, 0.7, "dash_effect")
			
			dash_triggered = true
			
		elseif(movement == "left") then
			local vel_x, vel_y = getPlayerVelocities()
			setPlayerVelocities(vel_x - horizontal_dash_boost, vel_y)
			
			-- adds visual effect that lasts for 10 frames
			addSpriteEffect(entity_id, "mods/ArcaneReliquary/files/other_gfx/dash_attack_left.xml", 10, 20, 10, 0.7, "dash_effect")
			
			dash_triggered = true
		end
		
		if(dash_triggered) then
			-- audio feedback
			local x, y = EntityGetTransform(entity_id)
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/bomb/create", x, y )
			
			-- gives 10 frames invencibility
			local game_effect_comp = GetGameEffectLoadTo( entity_id, "PROTECTION_ALL", true )
			if game_effect_comp ~= nil then
				ComponentSetValue( game_effect_comp, "frames", "10" )
			end
			
			-- applies cooldown
			local dash_attack_cooldown = 55
			removeCallback(entity_id, "dash_attack_listener")
			addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/player/dash_attack_recover.lua", dash_attack_cooldown, true, "dash_attack_recover")
			
			-- adds short duration damaging aura effect, which may vary according to other active relic effects 
			if(entityHasSimplifiedInternalVariable(entity_id, "firecrackers")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_gunpowder").path ) -- gunpowder attack
			elseif(entityHasSimplifiedInternalVariable(entity_id, "nuclear_glass")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_explosion").path ) -- explosive attack
			elseif(entityHasSimplifiedInternalVariable(entity_id, "shuriken")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_slash").path ) -- slash effect attack
			elseif(entityHasSimplifiedInternalVariable(entity_id, "poisonous_sting")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_burst_acid").path ) -- acid burst
			elseif(entityHasSimplifiedInternalVariable(entity_id, "magmatic_artifact")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_burst_lava").path ) -- lava burst
			elseif(entityHasSimplifiedInternalVariable(entity_id, "vile_artifact")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_burst_poison").path ) -- poison burst
			elseif(entityHasSimplifiedInternalVariable(entity_id, "meteor_fragment_molten")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_shockwave_fire").path ) -- fire shockwave trail
			elseif(entityHasSimplifiedInternalVariable(entity_id, "meteor_fragment_frozen")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_shockwave_ice").path ) -- ice shockwave trail
			elseif(entityHasSimplifiedInternalVariable(entity_id, "meteor_fragment_aluminum")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_shockwave_electric").path ) -- electric shockwave trail
			elseif(entityHasSimplifiedInternalVariable(entity_id, "meteor_fragment_silver")) then
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura_shockwave_thunderbolts").path ) -- thunderbolt shockwave trail
			else
				LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_slash_aura").path )
			end
		end
	end
end