dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local vertical_movement = getPlayerVerticalMovement()

if(vertical_movement == "down") then
	local creatures_on_player_feet = EntityGetInRadiusWithTag(x, y + 10, 5, "enemy") -- position which is close to the player's feet
	
	for i, creature_id in ipairs(creatures_on_player_feet) do
		
		SetRandomSeed( GameGetFrameNum(), math.random(1,50))
		-- Deals damage to creatures found
		local damageThreshold = 0.04
		
		EntityInflictDamage( creature_id, damageThreshold, "DAMAGE_MELEE", "stomped", "NORMAL", 0, 0)
		
		-- Applies effect on creature found
		LoadGameEffectEntityTo( creature_id, getCustomEffect("effect_bury").path )
		
		-- Applies downward velocity to creature
		--setCreatureVelocities(creature_id, 0, 500)
		
		-- Shoots player up
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x, (vel_y * 2) * -1)
		
	end
end