dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local vertical_movement = getPlayerVerticalMovement()

if(vertical_movement == "down") then
	local creatures_on_player_feet = EntityGetInRadiusWithTag(x, y + 10, 5, "enemy") -- position which is close to the player's feet
	
	for i, creature_id in ipairs(creatures_on_player_feet) do
		
		SetRandomSeed( GameGetFrameNum(), math.random(1,50))
		
		-- Deals damage to creatures found
		local damageThreshold = getInternalVariableValue(getPlayerEntity(), "electrified_boot_damage", "value_float")
		
		-- Doubles threshold if improved_stomp_relics variable is present
		if(entityHasSimplifiedInternalVariable(getPlayerEntity(), "improved_stomp_relics")) then
			damageThreshold = damageThreshold * 2
		end
		
		EntityInflictDamage( creature_id, damageThreshold, "DAMAGE_ELECTRICITY", "Electrocuting stomp", "NORMAL", 0, 0)
		
		-- Loads audiovisual feedback
		local creature_x, creature_y = EntityGetTransform(creature_id)
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", creature_x, creature_y)
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/stomp_explosion_blue.xml", creature_x, creature_y)
		--EntityLoad("data/entities/particles/particle_explosion/explosion_flare_blue_small.xml", creature_x, creature_y)
		
		-- Applies effect on creature found
		LoadGameEffectEntityTo( creature_id, "data/entities/misc/effect_electricity.xml" )
		
		-- Shoots player up
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x, (vel_y * 2) * -1)
		
	end
end