dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local vertical_movement = getPlayerVerticalMovement()

if(vertical_movement == "down") then
	local creatures_on_player_feet = EntityGetInRadiusWithTag(x, y + 10, 5, "enemy") -- position which is close to the player's feet
	
	for i, creature_id in ipairs(creatures_on_player_feet) do
		
		SetRandomSeed( GameGetFrameNum(), math.random(1,50))
		
		-- Deals explosive damage to creatures found
		local damageThreshold = getInternalVariableValue(getPlayerEntity(), "rocket_boot_damage", "value_float")
		
		-- Doubles threshold if improved_stomp_relics variable is present
		if(entityHasSimplifiedInternalVariable(getPlayerEntity(), "improved_stomp_relics")) then
			damageThreshold = damageThreshold * 2
		end
		
		EntityInflictDamage( creature_id, damageThreshold, "DAMAGE_EXPLOSION", "Explosive stomp", "NORMAL", 0, 0)
		
		-- Loads explosion on creature coordinates
		local creature_x, creature_y = EntityGetTransform(creature_id)
		
		EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/small_explosion.xml", creature_x, creature_y)
		
		-- Shoots player up
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x, (vel_y * 2) * -1)
		
	end
end