dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local vertical_movement = getPlayerVerticalMovement()

if(vertical_movement == "down") then
	local creatures_on_player_feet = EntityGetInRadiusWithTag(x, y + 10, 5, "enemy") -- position which is close to the player's feet
	
	for i, creature_id in ipairs(creatures_on_player_feet) do
	
		local creature_x, creature_y = EntityGetTransform(creature_id)
		
		SetRandomSeed( GameGetFrameNum(), math.random(1,50))
		-- Deals damage to creatures found
		local damageThreshold = Random(1, 3)
		
		EntityInflictDamage( creature_id, damageThreshold, "DAMAGE_MELEE", "stomped", "NORMAL", 0, 0)
		
		-- Shoots player up
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x, (vel_y * 2) * -1)
		
		-- Shoots side orbs
		local orb_right_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/blue_laser_orb.xml", creature_x + 10, creature_y - 5)
		setProjectileVelocitiesandGravity(orb_right_id, 140, 0)
		setProjectileShooter(orb_right_id, entity_id)
		local orb_left_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/blue_laser_orb.xml", creature_x - 10, creature_y - 5)
		setProjectileVelocitiesandGravity(orb_left_id, -140, 0)
		setProjectileShooter(orb_left_id, entity_id)
		
	end
end