dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local player_x, player_y = EntityGetTransform(entity_id)

-- if the player is not currently kicking and the kick wait flag is present, remove it
if(not string.find(entityGetCurrentAnimationName(entity_id), "kick") and entityHasSimplifiedInternalVariable(entity_id, "kick_wait")) then
	removeSimplifiedInternalVariable(entity_id, "kick_wait")
end

local cc_id = EntityGetFirstComponent(entity_id, "ControlsComponent")

-- detects if the player has kicked in the current frame
local kick_triggered = ComponentGetValueInt( cc_id, "mButtonFrameKick" ) == GameGetFrameNum()

-- shoots kick projectile after a 15 frames delay provided the kick wait flag is not present
local kick_delay = 15
if(kick_triggered and not entityHasSimplifiedInternalVariable(entity_id, "kick_wait")) then
	addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/player/extended_kick_shoot.lua", kick_delay, true, "extended_kick_shoot")
	addNewSimplifiedInternalVariable( entity_id, "kick_wait")
end


