dofile_once("mods/ArcaneReliquary/files/scripts/lists/load_on_explosion_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/collision_handlers_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

local entity_id = GetUpdatedEntityID()
local player_x, player_y = EntityGetTransform(entity_id)

-- item held is relied upon in order to find the correct rotation for the extended kick projectile
local rotation = getCurrentlyHeldItemRotation()

-- if no item is being held, skips
if(rotation == -1) then return end

-- loads the projectile then configures it with basic settings
local extended_kick_id = EntityLoad("mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/extended_kick.xml", player_x, player_y)
addNewSimplifiedInternalVariable( extended_kick_id, "relic_effect_projectile")
setProjectileShooter(extended_kick_id, entity_id)

-- enhances extended kick if STRONG_KICK perk is possessed
if(playerHasPerk("STRONG_KICK")) then
	setProjectileKnockback(extended_kick_id, 20)
	addProjectileDamageByType(extended_kick_id, "melee", 2.4)
end

-- this executes sinergy functions when specific relics are owned together with the sniper scope relic
for i,relic in ipairs(relics_list) do 
	if(relic.onextendedkick_function ~= nil) then
		relic.onextendedkick_function( entity_id, extended_kick_id)
	end
end

-- calculates velocities based on wand's rotation
local length = 200
if(entityHasSimplifiedInternalVariable(entity_id, "double_extended_kick_range")) then
	length = length * 2
end
rotation = rotation + math.rad(270)
local vel_y = math.cos( rotation ) * length
local vel_x = 0 - math.sin( rotation ) * length

-- sets calculated velocities on projectile
setProjectileVelocitiesandGravity(extended_kick_id, vel_x, vel_y)

-- this controls how often the player can shoot the extended kick projectile when kicking, the more the wait should be, the bigger the number should be
-- 40 frames is closely equivalent to the amount of frames between each kick animation
--removeCallback(entity_id, "extended_kick_listener")
--addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/player/readd_kick_listener.lua", 40, true, "readd_kick_listener")