dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local cc_id = EntityGetFirstComponent(entity_id, "ControlsComponent")
local kick_triggered = ComponentGetValueInt( cc_id, "mButtonFrameKick" ) == GameGetFrameNum()

local projectile_pool = {}
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board")) then table.insert(projectile_pool, "effectknife.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_cyan")) then table.insert(projectile_pool, "effectknife_freeze.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_blue")) then table.insert(projectile_pool, "effectknife_electric.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_orange")) then table.insert(projectile_pool, "effectknife_explode.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_green")) then table.insert(projectile_pool, "effectknife_slap.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_purple")) then table.insert(projectile_pool, "effectknife_slash.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_pink")) then table.insert(projectile_pool, "effectknife_mutate.xml") end
if(entityHasSimplifiedInternalVariable(entity_id, "cutting_board_blue_light")) then table.insert(projectile_pool, "effectknife_tele.xml") end


if(not isPlayerStanding() and (kick_triggered and getFlyEnergy() > 2)) then

	local projectile_definition = "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/" .. projectile_pool[Random(1,#projectile_pool)]
	local amount_min = 15
	local amount_max = 20
	local vel_min = 200
	local vel_max = 300

	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

	local how_many = Random(amount_min,amount_max)
	local angle_inc = ( 2 * 3.14159 ) / how_many
	local theta = 0

	for i=1,how_many do
		local projectile_id = EntityLoad(projectile_definition , x, y)
		addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
		setProjectileShooter(projectile_id, getPlayerEntity())

		local vel_x = math.cos( theta ) * Random(vel_min,vel_max)
		local vel_y = math.sin( theta ) * Random(vel_min,vel_max)
		theta = theta + angle_inc

		setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y)
	end

	addFlyEnergy(-2)
end