dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/load_on_explosion_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local vertical_movement = getPlayerVerticalMovement()

if(vertical_movement == "down") then
	local creatures_on_player_feet = EntityGetInRadiusWithTag(x, y + 10, 5, "enemy") -- position which is close to the player's feet
	
	for i, creature_id in ipairs(creatures_on_player_feet) do		
			
		-- Exceptions to the default behavior of shooting the player up when stomp ability triggers
		-------------------------------------------------------------------------------------------
		-- Shoots player up (if ground pound ability is currently being used, the player does not gain upwards momentum when stomping)
		local ground_pound_active = getInternalVariableValue(entity_id, "ground_pound_active", "value_bool")
		if(not ground_pound_active) then
			local vel_x, vel_y = getPlayerVelocities()
			setPlayerVelocities(vel_x, (vel_y * 2) * -1)
		end
		
		-- If ground pound is active, loads explosion if an enemy is caught
		if(ground_pound_active) then
			local creature_x, creature_y = EntityGetTransform(creature_id)
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/others/ground_pound_explosion.xml", creature_x, creature_y)
		end
		-------------------------------------------------------------------------------------------
		
		-- this executes the listening function to add specific effects from stomp related relics
		for i,relic in ipairs(relics_list) do 
			if(relic.onenemystomped_function ~= nil) then
				relic.onenemystomped_function( entity_id, creature_id)
			end
		end
		
	end
end