dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

-- activates ground pound on down key pressed
local cc_id = EntityGetFirstComponent(entity_id, "ControlsComponent")
local up_triggered = ComponentGetValueInt( cc_id, "mButtonFrameUp" ) == GameGetFrameNum()

if(isPlayerMoving() and up_triggered) then

	local vertical_boost = -1800
	local horizontal_push = 50
		
	-- gives player velocity boost according to current moving direction
	local uppercut_triggered = false
	local movement = getPlayerHorizontalMovement()
	if(movement == "right") then
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x + horizontal_push, vel_y + vertical_boost)

		uppercut_triggered = true
		
	elseif(movement == "left") then
		local vel_x, vel_y = getPlayerVelocities()
		setPlayerVelocities(vel_x - horizontal_push, vel_y + vertical_boost)
		
		uppercut_triggered = true
	end
	
	if(uppercut_triggered) then
		
		-- audio feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/bomb/create", x, y )
	
		-- adds visual effect that lasts for 10 frames
		addSpriteEffect(entity_id, "mods/ArcaneReliquary/files/other_gfx/uppercut.xml", 15, 20, 10, 0.7, "uppercut_effect")
		
		-- gives 10 frames invencibility
		local game_effect_comp = GetGameEffectLoadTo( entity_id, "PROTECTION_ALL", true )
		if game_effect_comp ~= nil then
			ComponentSetValue( game_effect_comp, "frames", "10" )
		end
		
		-- applies cooldown
		local uppercut_cooldown = 65
		removeCallback(entity_id, "uppercut_listener")
		addNewLuaCallback(entity_id, "overtime", "mods/ArcaneReliquary/files/scripts/player/uppercut_recover.lua", uppercut_cooldown, true, "uppercut_recover")
		
		-- adds short duration damaging aura effect, which may vary according to other active relic effects 
		--[[
		if(entityHasSimplifiedInternalVariable(entity_id, "ember_stone")) then
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_uppercut_aura_fireball").path )
		elseif(entityHasSimplifiedInternalVariable(entity_id, "tesla_coil")) then
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_uppercut_aura_thunderbolt").path )
		else
			LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_uppercut_aura").path )
		end
		]]
		LoadGameEffectEntityTo( entity_id, getCustomEffect("effect_uppercut_aura").path )
	end
	
end