dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()

local vel_x, vel_y = getPlayerVelocities()
if(vel_y == 60) then
	setInternalVariableValue(entity_id, "double_jump", "value_bool", true)
end

local double_jump = getInternalVariableValue(entity_id, "double_jump", "value_bool")
local double_jump_count = getInternalVariableValue(entity_id, "double_jump_count", "value_int")
local double_jump_default_amount = getInternalVariableValue(entity_id, "double_jump_default_amount", "value_int")

local cc_id = EntityGetFirstComponent(entity_id, "ControlsComponent")
local jump_triggered = ComponentGetValueInt( cc_id, "mButtonFrameFly" ) == GameGetFrameNum()

if(jump_triggered) then
	
	local cpc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")

	local x, y = EntityGetTransform(entity_id)
	local wallhit_left = RaytraceSurfaces(x - 5, y + 3, x - 5, y - 5)
    local wallhit_right = RaytraceSurfaces(x + 5, y + 3, x + 5, y - 5)
	local left_down = tonumber(ComponentGetValueInt( cc_id, "mButtonDownLeft" ))
	local right_down = tonumber(ComponentGetValueInt( cc_id, "mButtonDownRight" ))
	local jump_down = tonumber(ComponentGetValueInt( cc_id, "mButtonDownFly" ))
	
	local vertical_momentum = -150
	if(playerHasPerk("FASTER_LEVITATION") or GameGetGameEffectCount(getPlayerEntity(), "FASTER_LEVITATION") > 0) then -- synergy with FASTER_LEVITATION perk and status effect, increases the amount of double jumps
		double_jump_default_amount = double_jump_default_amount + 3
	end
	
	local double_jump_effect = "mods/ArcaneReliquary/files/entity_definitions/particle_explosions/doublejump_explosion.xml"
	if(playerHasPerk("LEVITATION_TRAIL")) then -- synergy with LEVITATION_TRAIL, replacing default double jump effect with a barrage of levitation trail projectiles
		double_jump_effect = "mods/ArcaneReliquary/files/entity_definitions/load_on_explosion/launch_circular_projectiles_levitation_trail.xml"
	end
	
	-- triggers wall jump from wall on left
	if(wallhit_left and left_down == 1) then
		--GamePrint("Left wall hit")
		local vel_x, vel_y = getPlayerVelocities()
		if(vel_y <= 25) then
			setPlayerVelocities(vel_x + 200, vertical_momentum * 3)
			--GamePrint("Extra momentum")
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/walljump_explosion.xml", x, y)
		else
			setPlayerVelocities(vel_x + 200, vertical_momentum)
		end
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/bomb/create", x, y )
	end
	-- triggers wall jump from wall on right
	if(wallhit_right and right_down == 1) then
		--GamePrint("Right wall hit")
		local vel_x, vel_y = getPlayerVelocities()
		if(vel_y <= 25) then
			setPlayerVelocities(vel_x - 200, vertical_momentum * 3)
			--GamePrint("Extra momentum")
			EntityLoad("mods/ArcaneReliquary/files/entity_definitions/particle_explosions/walljump_explosion.xml", x, y)
		else
			setPlayerVelocities(vel_x - 200, vertical_momentum)
		end
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/bomb/create", x, y )
	end
	
	-- triggers double jump
	if(jump_down and not wallhit_left and not wallhit_right and not isPlayerStanding() and double_jump) then
		local vel_x, vel_y = getPlayerVelocities()
		if(vel_y >= 0 and vel_y <= 350) then
			setPlayerVelocities(vel_x, vertical_momentum * 2)
			EntityLoad(double_jump_effect, x, y)
			
			double_jump_count = double_jump_count + 1
			setInternalVariableValue(entity_id, "double_jump_count", "value_int", double_jump_count)
			if(double_jump_count >= double_jump_default_amount) then
				setInternalVariableValue(entity_id, "double_jump", "value_bool", false)
				setInternalVariableValue(entity_id, "double_jump_count", "value_int", 0)
			end
			GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/bomb/create", x, y )
		end
	end
end
