dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local scatter = 0.1

local entity_id = GetUpdatedEntityID()
local shooter_id = getPlayerEntity()
local pos_x, pos_y = EntityGetTransform( entity_id )



SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)

if(Random(1,2) == 1) then

	local projectile_definition = getInternalVariableValue(entity_id, "projectile_definition", "value_string")
	local projectile_amount = getInternalVariableValue(entity_id, "projectile_amount", "value_int")
	local detection_range = getInternalVariableValue(entity_id, "detection_range", "value_int")
	local projectile_velocity_min = getInternalVariableValue(entity_id, "vel_min", "value_int")
	local projectile_velocity_max = getInternalVariableValue(entity_id, "vel_max", "value_int")

	-- locate player
	local enemy, enemy_x, enemy_y
	local min_dist = 9999
	for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, "player_unit")) do
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end

	if not enemy then return end

	-- check los
	if RaytraceSurfacesAndLiquiform(pos_x, pos_y, enemy_x, enemy_y) then return end

	-- direction
	local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
	vel_x,vel_y = vec_normalize(vel_x, vel_y)

	for i=1,projectile_amount do
		-- scatter
		local vx,vy = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

		-- apply velocity & shoot
		vx,vy = vec_mult(vx,vy, rand(projectile_velocity_min, projectile_velocity_max))
		local projectile_id = shoot_projectile( EntityGetClosestWithTag(  pos_x, pos_y, "enemy"), projectile_definition, pos_x, pos_y, vx, vy)
	end

end