dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local owner_id = getInternalVariableValue(entity_id, "owner", "value_int")

-- first makes a check if host entity has the signal tag, and stops script otherwise
if(not entityHasSimplifiedInternalVariable(owner_id, EntityGetName(entity_id))) then return end

GamePrint(">>> player has damaged an enemy!")

local damage_author_tag = ""
if(owner_id == getPlayerEntity()) then
	damage_author_tag = "enemy"
else
	damage_author_tag = "player_unit"
end

SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)

local powerful_shot_chance = Random(1,5)
local powerful_shot = (powerful_shot_chance == 1)

local can_shoot = getInternalVariableValue(entity_id, "can_shoot", "value_bool")
if(can_shoot ~= nil and not can_shoot) then return end -- if can_shoot flag is present, but it is false, skips shooting

if(Random(1,2) == 1) then
	
	local detection_range = getInternalVariableValue(entity_id, "detection_range", "value_int")
	local projectile_definition = getInternalVariableValue(entity_id, "retaliation_projectile_definition", "value_string")
	local projectile_amount = getInternalVariableValue(entity_id, "retaliation_projectile_amount", "value_int")
	local projectile_velocity_min = getInternalVariableValue(entity_id, "retaliation_projectile_vel_min", "value_int")
	local projectile_velocity_max = getInternalVariableValue(entity_id, "retaliation_projectile_vel_max", "value_int")

	local scatter = 0.1 * projectile_amount

	local target_x, target_y = EntityGetTransform(owner_id)

	-- check los
	if RaytraceSurfaces(pos_x, pos_y, target_x, target_y) then return end

	-- direction
	local vel_x, vel_y = vec_sub(target_x, target_y, pos_x, pos_y)
	vel_x,vel_y = vec_normalize(vel_x, vel_y)

	for i=1,projectile_amount do
		-- scatter
		local vx,vy = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

		-- apply velocity & shoot
		vx,vy = vec_mult(vx,vy, rand(projectile_velocity_min, projectile_velocity_max))
		local projectile_id = shoot_projectile( entity_id, projectile_definition, pos_x, pos_y, vx, vy)
		setProjectileShooter(projectile_id, EntityGetWithTag( damage_author_tag )[1]) -- hacky way to prevent projectiles from hitting the player but also to prevent them from being affected by relics
		
		local kill_on_shot = getInternalVariableValue(entity_id, "kill_on_shot", "value_bool")
		if(kill_on_shot ~= nil and kill_on_shot) then
			EntityKill(entity_id)
		end
	end
end