dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()

local effect_to_load = getInternalVariableValue(entity_id, "effect_to_load", "value_string")
local gaec_id = EntityGetFirstComponentIncludingDisabled(entity_id, "GameAreaEffectComponent")
local radius = ComponentGetValue2(gaec_id, "radius")
local visual_feedback_entity_definition = getInternalVariableValue(entity_id, "visual_feedback_entity_definition", "value_string")

local field_x, field_y = EntityGetTransform(entity_id)

local creatures = EntityGetInRadiusWithTag(field_x, field_y, radius, "mortal")

-- applies effect on all creatures within field
for i, creature_id in ipairs(creatures) do

	-- Loads audiovisual feedback and applies effect if it wasn't applied yet
	if(GameGetGameEffectCount(creature_id, effect_to_load) == 0) then
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", field_x, field_y )
		EntityLoad(visual_feedback_entity_definition, field_x, field_y)
		GetGameEffectLoadTo( creature_id, effect_to_load, true )
	end
end



