dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local projectile_definition = getInternalVariableValue(entity_id, "projectile_definition", "value_string")
local amount_min = getInternalVariableValue(entity_id, "amount_min", "value_int")
local amount_max = getInternalVariableValue(entity_id, "amount_max", "value_int")
local vel_min = getInternalVariableValue(entity_id, "vel_min", "value_int")
local vel_max = getInternalVariableValue(entity_id, "vel_max", "value_int")

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

local how_many = Random(amount_min,amount_max)
local angle_inc = ( 2 * 3.14159 ) / how_many
local theta = 0

for i=1,how_many do
	local projectile_id = EntityLoad(projectile_definition , pos_x, pos_y)
	addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
	setProjectileShooter(projectile_id, EntityGetClosestWithTag(  pos_x, pos_y, "enemy"))

	local vel_x = math.cos( theta ) * Random(vel_min,vel_max)
	local vel_y = math.sin( theta ) * Random(vel_min,vel_max)
	theta = theta + angle_inc

	setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y)
end
