dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

local spell_definitions = getSpellDefinitionsFromWand(getCurrentlyEquippedWandId())
local amount_min = getInternalVariableValue(entity_id, "amount_min", "value_int")
local amount_max = getInternalVariableValue(entity_id, "amount_max", "value_int")
local vel_min = getInternalVariableValue(entity_id, "vel_min", "value_int")
local vel_max = getInternalVariableValue(entity_id, "vel_max", "value_int")

local shooter_tag = getInternalVariableValue(entity_id, "shooter_tag", "value_string")

local how_many = Random(amount_min,amount_max)
local angle_inc = ( 2 * 3.14159 ) / how_many
local theta = 0

for i=1,how_many do
	local projectile_id = EntityLoad(spell_definitions[Random(1,#spell_definitions)] , pos_x, pos_y)
	addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
	if(shooter_tag ~= nil and shooter_tag == "enemy") then
		setProjectileShooter(projectile_id, EntityGetClosestWithTag(  pos_x, pos_y, "enemy"))
	else
		setProjectileShooter(projectile_id, getPlayerEntity())
	end

	local vel_x = math.cos( theta ) * Random(vel_min,vel_max)
	local vel_y = math.sin( theta ) * Random(vel_min,vel_max)
	theta = theta + angle_inc

	setProjectileVelocitiesandGravity(projectile_id, vel_x, vel_y)
end
