dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

--GamePrint("### shrapnel launched")

local entity_id = GetUpdatedEntityID()

local projectile_vel_x, projectile_vel_y = getProjectileVelocitiesandGravity(entity_id)
local projectile_pos_x, projectile_pos_y = EntityGetTransform(entity_id)

local projectiles_pool = {
	"mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/freezesolidbomb.xml",
	"mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/instakillbomb.xml",
	"mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/petrifybomb.xml",
}

local angles = {0.05, 0.1, 0.15, 0.2, 0.25}

local angle = 0 - math.atan2( projectile_vel_y, projectile_vel_x )
local length = 250

SetRandomSeed( GameGetFrameNum(), projectile_pos_x + projectile_pos_y + entity_id)

-- positive angled shots
for i=1,2 do
	local angle_up = angle + 3.1415 * angles[Random(1,#angles)]
	
	projectile_vel_x = math.cos( angle_up ) * length
	projectile_vel_y = 0 - math.sin( angle_up ) * length
	
	local projectile_id = EntityLoad(projectiles_pool[Random(1,#projectiles_pool)] , projectile_pos_x, projectile_pos_y)
	addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
	
	setProjectileMass(projectile_id, Random(4, 6))
	setProjectileVelocitiesandGravity(projectile_id, projectile_vel_x, projectile_vel_y)
	setProjectileShooter(projectile_id, getPlayerEntity())
end

-- straight shot
local angle_straight = angle + 3.1415 * 0.0001
projectile_vel_x = math.cos( angle_straight ) * length
projectile_vel_y = 0 - math.sin( angle_straight ) * length

local projectile_id = EntityLoad( projectiles_pool[Random(1,#projectiles_pool)], projectile_pos_x, projectile_pos_y)
addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")

setProjectileMass(projectile_id, Random(4, 6))
setProjectileVelocitiesandGravity(projectile_id, projectile_vel_x, projectile_vel_y)
setProjectileShooter(projectile_id, getPlayerEntity())

-- negative angled shots
for i=1,2 do
	local angle_up = angle - 3.1415 * angles[Random(1,#angles)]
	
	projectile_vel_x = math.cos( angle_up ) * length
	projectile_vel_y = 0 - math.sin( angle_up ) * length
	
	local projectile_id = EntityLoad( projectiles_pool[Random(1,#projectiles_pool)], projectile_pos_x, projectile_pos_y)
	addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
	
	setProjectileMass(projectile_id, Random(4, 6))
	setProjectileVelocitiesandGravity(projectile_id, projectile_vel_x, projectile_vel_y)
	setProjectileShooter(projectile_id, getPlayerEntity())
end

EntityKill(entity_id)