dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform(entity_id)

local projectile_shot_down_definition = getInternalVariableValue(entity_id, "projectile_shot_down_definition", "value_string")
local down_vel_min = getInternalVariableValue(entity_id, "down_vel_min", "value_int")
local down_vel_max = getInternalVariableValue(entity_id, "down_vel_max", "value_int")
local max_projectiles_shot = getInternalVariableValue(entity_id, "max_projectiles_shot", "value_int")

-- if maximum projectiles shot reaches zero, callback is removed
if(max_projectiles_shot <= 0) then
	removeCallback(entity_id, "launch_projectile_down")
	return
end

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

local projectile_id = EntityLoad(projectile_shot_down_definition, pos_x, pos_y)
addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
setProjectileShooter(projectile_id, getPlayerEntity())
setProjectileVelocitiesandGravity(projectile_id, 0, Random(down_vel_min, down_vel_max))

-- decreases from maximum projectiles shot
setInternalVariableValue(entity_id, "max_projectiles_shot", "value_int", max_projectiles_shot - 1)