dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

local spell_definitions = getSpellDefinitionsFromWand(getCurrentlyEquippedWandId())
local projectile_definition = spell_definitions[Random(1,#spell_definitions)]
local projectile_velocity = getInternalVariableValue(entity_id, "projectile_velocity", "value_int")
local max_projectiles_shot = getInternalVariableValue(entity_id, "max_projectiles_shot", "value_int")

-- if maximum projectiles shot reaches zero, callback is removed
if(max_projectiles_shot ~= nil) then
	if(max_projectiles_shot <= 0) then
		removeCallback(entity_id, "launch_projectile_random_direction_wand_spells")
		return
	end
end

local angle = math.rad(Random(0,359))

local vel_x = math.cos( angle ) * projectile_velocity
local vel_y = 0 - math.sin( angle ) * projectile_velocity

local projectile_id = shoot_projectile( entity_id, projectile_definition, pos_x, pos_y, vel_x, vel_y )
addNewSimplifiedInternalVariable(projectile_id, "relic_effect_projectile")
setProjectileShooter(projectile_id, getPlayerEntity())

-- decreases from maximum projectiles shot
setInternalVariableValue(entity_id, "max_projectiles_shot", "value_int", max_projectiles_shot - 1)