dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local projectile_entity_id = GetUpdatedEntityID()
local projectile_x, projectile_y = EntityGetTransform(projectile_entity_id)

local captured_enemy_id = getInternalVariableValue(projectile_entity_id, "captured_enemy_id", "value_int")

-- if captured creature is alive, updates its position to match the projectile's
if(captured_enemy_id ~= 0 and EntityGetIsAlive(captured_enemy_id)) then
	
	-- updates enemy coordinates
	local captured_enemy_x, captured_enemy_y = EntityGetTransform(captured_enemy_id)
	EntitySetTransform(captured_enemy_id, projectile_x, projectile_y)
end

-- if enemy dies, reenables collision handler so that it can capture another enemy
if(not EntityGetIsAlive(captured_enemy_id)) then
	-- reinits captured enemy id variable
	setInternalVariableValue(projectile_entity_id, "captured_enemy_id", "value_int", 0)
	-- adds collision trigger back
	if(not entityHasCollisionTrigger(projectile_entity_id, "rotating_projectile_capture_enemy")) then
		attachCollisionTrigger(projectile_entity_id, 8, "enemy", false, "rotating_projectile_capture_enemy")
	end
end