dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()

local angle = getInternalVariableValue(entity_id, "angle", "value_float")
local rotation = getInternalVariableValue(entity_id, "rot", "value_int")
local owner_id = getInternalVariableValue(entity_id, "owner", "value_int")
setProjectileShooter(entity_id, owner_id)
local max_radius = getInternalVariableValue(entity_id, "length", "value_int")

-- radius pulsate config
-- ---------------------
-- obtains radius settings
local current_radius = getInternalVariableValue(entity_id, "current_radius", "value_int")
local min_radius = getInternalVariableValue(entity_id, "min_radius", "value_int")
local pulsate_status = getInternalVariableValue(entity_id, "pulsate_status", "value_string")

-- calculates current radius
if(pulsate_status == "increase") then
	current_radius = current_radius + 1
elseif(pulsate_status == "decrease") then
	current_radius = current_radius - 1
end

if(current_radius <= min_radius) then
	pulsate_status = "increase"
end
if(current_radius >= max_radius) then
	pulsate_status = "decrease"
end

setInternalVariableValue(entity_id, "current_radius", "value_int", current_radius)
setInternalVariableValue(entity_id, "pulsate_status", "value_string", pulsate_status)
-- ---------------------


local clockwise_rotation = getInternalVariableValue(entity_id, "clockwise_rotation", "value_bool")

-- specific treatment for the sawblade rotating projetile
if(EntityGetName(entity_id) == "rotating_shield_projectile_disk_bullet") then
	local sawblade_target_tag = ""
	if(owner_id == getPlayerEntity()) then
		sawblade_target_tag = "enemy"
	else
		sawblade_target_tag = "player_unit"
	end
	
	local adc_id = EntityGetFirstComponentIncludingDisabled(enemy_id, "AreaDamageComponent")
	ComponentSetValue2( adc_id, "entities_with_tag", sawblade_target_tag)
end

if(clockwise_rotation ~= nil and clockwise_rotation) then
	angle = angle + rotation * -0.02
else
	angle = angle + rotation * 0.02
end

setInternalVariableValue(entity_id, "angle", "value_float", angle)

angle = angle + rotation

if ( owner_id ~= NULL_ENTITY ) then
	local x, y = EntityGetTransform( owner_id )
	
	if ( x ~= nil ) and ( y ~= nil ) then
		local px = x + math.cos( angle ) * current_radius
		local py = y - math.sin( angle ) * current_radius
		
		EntitySetTransform( entity_id, px, py )
	else
		EntityKill( entity_id )
	end
end