dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local how_many = getInternalVariableValue(entity_id, "rotating_projectiles_amount", "value_int")
local length = getInternalVariableValue(entity_id, "radius", "value_int")
local rotating_projectile_definition = getInternalVariableValue(entity_id, "rotating_projectile_definition", "value_string")
local rotation_speed = getInternalVariableValue(entity_id, "rotation_speed", "value_int")

local host_entity_id = getInternalVariableValue(entity_id, "host_entity_id", "value_int")

local angle_inc = ( 2 * 3.14159 ) / how_many
local theta = math.rad(6)-GameGetFrameNum() / 10.0

if ( host_entity_id ~= nil ) and ( host_entity_id ~= NULL_ENTITY ) then
	for i=1,how_many do
		local new_x = pos_x + math.cos( theta ) * length
		local new_y = pos_y + math.sin( theta ) * length
		
		local part_id = EntityLoad(rotating_projectile_definition, new_x, new_y)
		if(host_entity_id == getPlayerEntity()) then
			addNewSimplifiedInternalVariable(part_id, "relic_effect_projectile")
		end
		EntityRemoveTag(part_id, "projectile" )
		setProjectileShooter(part_id, host_entity_id)
		EntityAddChild(host_entity_id, part_id)
		
		EntityAddComponent( part_id, "VariableStorageComponent", 
			{
				name = "angle",
				value_float = theta,
			})
			
		EntityAddComponent( part_id, "VariableStorageComponent", 
			{
				name = "rot",
				value_int = rotation_speed,
			})
			
		EntityAddComponent( part_id, "VariableStorageComponent", 
			{
				name = "owner",
				value_int = host_entity_id,
			})
			
		EntityAddComponent( part_id, "VariableStorageComponent", 
			{
				name = "length",
				value_int = length,
			})
			
		theta = theta + angle_inc
	end
end

EntityKill( entity_id )
