dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local hc_id = EntityGetFirstComponentIncludingDisabled( entity_id, "HomingComponent" )

local pos_x, pos_y = EntityGetTransform( entity_id )

-- locate nearest enemy
local detection_range = 200
local target_tag = "enemy"
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, detection_range, target_tag)) do

	local x, y = EntityGetFirstHitboxCenter( id )
	local dist = get_distance(pos_x, pos_y, x, y)
	if dist < min_dist then
		min_dist = dist
		enemy = id
		enemy_x = x
		enemy_y = y
	end
end

if not enemy then -- if no enemy was located, fly follows the player
	ComponentSetValue2( hc_id, "target_tag", "player_unit" )
	return
end

-- check los
if RaytraceSurfaces(pos_x, pos_y, enemy_x, enemy_y) then -- if an enemy is found within range and light of sight, fly follows this enemy
	ComponentSetValue2( hc_id, "target_tag", target_tag )
end