dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local range = 100
local projectile_velocity = 950
local scatter = 0.1

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "player_unit")) do
	local x, y = EntityGetFirstHitboxCenter( id )
	local dist = get_distance(pos_x, pos_y, x, y)
	if dist < min_dist then
		min_dist = dist
		enemy = id
		enemy_x = x
		enemy_y = y
	end
end

if not enemy then return end

local enemy_x, enemy_y = EntityGetTransform(enemy)

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- scatter
SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)
local projectile_id = shoot_projectile( EntityGetClosestWithTag(  pos_x, pos_y, "enemy"), "mods/ArcaneReliquary/files/entity_definitions/custom_projectiles/thunderbolt_red.xml", pos_x, pos_y, vel_x, vel_y)