dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")

local LOAD_KEY = "ARCANERELIQUARY_NEWGAME_FLAG"
local mod_version = "12.0"

-- adding customized listeners to base enemy entity definition file
local fileContents = ModTextFileGetContent("data/entities/base_humanoid.xml")
local replacement = [[
	</ItemChestComponent>
	<LuaComponent
	    execute_every_n_frame="-1"
	    script_death="mods/ArcaneReliquary/files/scripts/main_listeners/enemy_death.lua"
	    remove_after_executed="1" >
	</LuaComponent>
	<LuaComponent
		execute_every_n_frame="1"
	    script_source_file="mods/ArcaneReliquary/files/scripts/other_listeners/enemy_apply_random_buffs.lua"
	    remove_after_executed="1"
		execute_times="1">
	</LuaComponent>
	<LuaComponent
		execute_every_n_frame="25"
	    script_source_file="mods/ArcaneReliquary/files/scripts/other_listeners/enemy_apply_special_items_drop_chance.lua"
	    remove_after_executed="1"
		execute_times="1">
	</LuaComponent>
	<LuaComponent
		execute_every_n_frame="1"
	    script_damage_received="mods/ArcaneReliquary/files/scripts/main_listeners/enemy_damage_received.lua"
	    remove_after_executed="0"
	    execute_every_n_frame="1">
	</LuaComponent>
	<LuaComponent
		execute_every_n_frame="1"
	    script_kick="mods/ArcaneReliquary/files/scripts/main_listeners/enemy_kicked.lua"
	    remove_after_executed="0"
	    execute_every_n_frame="1">
	</LuaComponent>
]]
fileContents = string.gsub(fileContents, "</ItemChestComponent>", replacement)

fileContents = string.gsub(fileContents, "acid,lava", "acid,lava,corrosive_blood") -- replaces list of damaging materials to include new ones from this mod
fileContents = string.gsub(fileContents, "0.004,0.004", "0.004,0.004,0.002")

ModTextFileSetContent("data/entities/base_humanoid.xml", fileContents )

-- adding customized listeners to base files for physics objects
local file_physics_1 = ModTextFileGetContent("data/entities/base_item_physics.xml")
replacement = [[
	</PhysicsImageShapeComponent>
	<LuaComponent
	    script_kick="mods/ArcaneReliquary/files/scripts/other_listeners/physics_object_kicked.lua">
	</LuaComponent>
]]
file_physics_1 = string.gsub(file_physics_1, "</PhysicsImageShapeComponent>", replacement)

ModTextFileSetContent("data/entities/base_item_physics.xml", file_physics_1 )

local file_physics_2 = ModTextFileGetContent("data/entities/base_item_physics2.xml")
replacement = [[
	</PhysicsImageShapeComponent>
	<LuaComponent
	    script_kick="mods/ArcaneReliquary/files/scripts/other_listeners/physics_object_kicked.lua">
	</LuaComponent>
]]
file_physics_2 = string.gsub(file_physics_2, "</PhysicsImageShapeComponent>", replacement)

ModTextFileSetContent("data/entities/base_item_physics2.xml", file_physics_2 )

-- adding customized code to gold pickup script
local scriptContents = ModTextFileGetContent("data/scripts/items/gold_pickup.lua")
replacement = [[dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/relics_list.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/custom_effects_list.lua")
function item_pickup]]
scriptContents = string.gsub(scriptContents, "function item_pickup", replacement)
ModTextFileSetContent("data/scripts/items/gold_pickup.lua", scriptContents )

scriptContents = ModTextFileGetContent("data/scripts/items/gold_pickup.lua")
replacement = [[
	for i,relic in ipairs(relics_list) do 
		if(relic.ongoldpickup_function ~= nil) then
			relic.ongoldpickup_function()
		end
	end
]]
scriptContents = string.gsub(scriptContents, "local money = 0", replacement)
ModTextFileSetContent("data/scripts/items/gold_pickup.lua", scriptContents )

-- adding custom code to holy mountain left area spawning script
local scriptContents2 = ModTextFileGetContent("data/scripts/biomes/temple_altar_left.lua")
replacement = [[dofile_once("data/scripts/biomes/temple_altar_top_shared.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/lists/interactive_machines_list.lua")
]]
scriptContents2 = string.gsub(scriptContents2, 'dofile_once%("data/scripts/biomes/temple_altar_top_shared.lua"%)', replacement)
ModTextFileSetContent("data/scripts/biomes/temple_altar_left.lua", scriptContents2 )

scriptContents2 = ModTextFileGetContent("data/scripts/biomes/temple_altar_left.lua")
replacement = [[
function spawn_statue( x, y )
	EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/machine_spawner.xml", x + 80, y)
]]
scriptContents2 = string.gsub(scriptContents2, "function spawn_statue%( x, y %)", replacement)
ModTextFileSetContent("data/scripts/biomes/temple_altar_left.lua", scriptContents2 )

-- adding custom code to broken wand spells script
local scriptContents3 = ModTextFileGetContent("data/scripts/items/broken_wand_spells.lua")
replacement = [[dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
]]
scriptContents3 = string.gsub(scriptContents3, 'dofile_once%("data/scripts/lib/utilities.lua"%)', replacement)
ModTextFileSetContent("data/scripts/items/broken_wand_spells.lua", scriptContents3 )

scriptContents3 = ModTextFileGetContent("data/scripts/items/broken_wand_spells.lua")
replacement = [[
	}
	if(entityHasSimplifiedInternalVariable(getPlayerEntity(), "wand_necklace")) then
		spells = nil
		spells = {
			"data/entities/projectiles/deck/bouncy_orb.xml",
			"data/entities/projectiles/deck/disc_bullet_big.xml",
			"data/entities/projectiles/deck/bullet_heavy.xml",
			"data/entities/projectiles/deck/bullet_slow.xml",
			"data/entities/projectiles/thunderball.xml",
			"data/entities/projectiles/deck/rocket.xml",
			"data/entities/projectiles/deck/spitter_tier_2.xml",
			"data/entities/projectiles/deck/spitter_tier_3.xml",
			"data/entities/projectiles/deck/grenade_tier_2.xml",
			"data/entities/projectiles/deck/grenade_tier_3.xml",
			"data/entities/projectiles/deck/grenade.xml",
			"data/entities/projectiles/deck/glue_shot.xml"
		}
	end
]]
scriptContents3 = string.gsub(scriptContents3, "%}", replacement)
ModTextFileSetContent("data/scripts/items/broken_wand_spells.lua", scriptContents3 )

-- adding custom code to gold orb script
local scriptContents4 = ModTextFileGetContent("data/scripts/items/gold_orb.lua")
replacement = [[dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/ArcaneReliquary/files/scripts/utilities/arcanereliquary_utilities.lua")
]]
scriptContents4 = string.gsub(scriptContents4, 'dofile_once%("data/scripts/lib/utilities.lua"%)', replacement)
ModTextFileSetContent("data/scripts/items/gold_orb.lua", scriptContents4 )

scriptContents4 = ModTextFileGetContent("data/scripts/items/gold_orb.lua")
replacement = [[
	if ( outcome == 1 and not entityHasSimplifiedInternalVariable(getPlayerEntity(), "wealth_necklace")) then
]]
scriptContents4 = string.gsub(scriptContents4, "if %( outcome == 1 %) then", replacement)
ModTextFileSetContent("data/scripts/items/gold_orb.lua", scriptContents4 )

-- vanilla enemy customizations to prevent enemy spawned by other enemies from being exploited for relic chests
local fileContents2 = ModTextFileGetContent("data/entities/projectiles/bat.xml")
replacement = [[spawn_entity="mods/ArcaneReliquary/files/entity_definitions/overloaded_entities/bat.xml"]]
fileContents2 = string.gsub(fileContents2, 'spawn_entity="data/entities/animals/bat.xml"', replacement)
ModTextFileSetContent("data/entities/projectiles/bat.xml", fileContents2 )

local scriptContents3 = ModTextFileGetContent("data/scripts/animals/pebble_spawn.lua")
replacement = [[mods/ArcaneReliquary/files/entity_definitions/overloaded_entities/pebble_physics.xml]]
scriptContents3 = string.gsub(scriptContents3, 'data/entities/animals/pebble_physics.xml', replacement)
ModTextFileSetContent("data/scripts/animals/pebble_spawn.lua", scriptContents3 )

function OnPlayerSpawned(player)
	
	if GlobalsGetValue(LOAD_KEY, "0") == "1" then
		return
	end
	GlobalsSetValue(LOAD_KEY, "1")
	
	-- gui related global variables
	GlobalsSetValue("ARCANERELIQUARY_RENDER_MAIN_GUI_FLAG", "1")
	
	-- Intro text
	local extra_info = ""
	if(ModSettingGet("ArcaneReliquary.no_buffs_mode") == "ENABLED") then
		extra_info = "\nNo Buffs Mode is ENABLED, relic chests will drop from enemies with the chest marker above their heads"
	else
		extra_info = "\nNo Buffs Mode is DISABLED, relic chests will drop from enemies with buffs"
	end
	GamePrintImportant("Welcome to Arcane Reliquary v" .. mod_version, "Be on the look for special relics that give you various buffs" .. extra_info, "mods/ArcaneReliquary/files/other_gfx/custom_decoration_mod_intro.png")
	
	
	-- Main event listeners
	addNewLuaCallback(player, "on_damaged", "mods/ArcaneReliquary/files/scripts/main_listeners/damage_received.lua", 5, false, "damage_received")
	addNewLuaCallback(player, "on_wand_fired", "mods/ArcaneReliquary/files/scripts/main_listeners/wand_fired.lua", 5, false, "wand_fired")
	addNewLuaCallback(player, "on_projectile_shot", "mods/ArcaneReliquary/files/scripts/main_listeners/spell_cast.lua", 5, false, "spell_cast")
	addNewLuaCallback(player, "overtime", "mods/ArcaneReliquary/files/scripts/main_listeners/overtime_effects.lua", 55, false, "overtime_effects")
	addNewLuaCallback(player, "overtime", "mods/ArcaneReliquary/files/scripts/main_listeners/overtime_effects_slow.lua", 105, false, "overtime_effects_slow")
	
	-- listener that periodically checks if main gui is loaded
	addNewLuaCallback(player, "overtime", "mods/ArcaneReliquary/files/scripts/main_listeners/main_gui_reload.lua", 10, false, "main_gui_reload")
	
	-- internal variables
	-- sets enemy kills
	addNewInternalVariable(player, "enemy_kills", "value_int", 0)
	-- sets gold nuggets collected
	addNewInternalVariable(player, "gold_nuggets_collected", "value_int", 0)
	-- sets last enemy projectile definition
	addNewInternalVariable(player, "enemy_projectile_definition", "value_string", "")
	-- sets lava damage bonus
	addNewInternalVariable(player, "lava_damage_bonus", "value_int", 0)
	-- sets drunk water damage multiplier
	addNewInternalVariable(player, "water_damage_multiplier", "value_int", 0)
	-- sets last projectile detected material id
	addNewInternalVariable(player, "last_material_detected_projectile", "value_string", "air")
	-- sets last player detected material id
	addNewInternalVariable(player, "last_material_detected_player", "value_string", "air")
	-- sets last companion detected material id
	addNewInternalVariable(player, "last_material_detected_companion", "value_string", "air")
	-- sets prize wheel count
	addNewInternalVariable(player, "prize_wheel_count", "value_int", 0)
	-- sets double jump control variables
	addNewInternalVariable(player, "double_jump", "value_bool", true)
	addNewInternalVariable(player, "double_jump_count", "value_int", 0)
	addNewInternalVariable(player, "double_jump_default_amount", "value_int", 1)
	-- sets ground pound control variables
	addNewInternalVariable(player, "ground_pound_active", "value_bool", false)
	-- sets trick kill bonus damage variable
	addNewInternalVariable(player, "trick_kill_damage_counter", "value_int", 0)
	-- damage absortion variables
	addNewInternalVariable(player, "damage_absorbed", "value_float", 0)
	addNewInternalVariable(player, "damage_absorbed_melee", "value_float", 0)
	addNewInternalVariable(player, "damage_absorbed_explosion", "value_float", 0)
	addNewInternalVariable(player, "damage_absorbed_fire", "value_float", 0)
	addNewInternalVariable(player, "damage_absorbed_acid", "value_float", 0)
	addNewInternalVariable(player, "damage_absorbed_poison", "value_float", 0)
	-- shoot frame variable
	addNewInternalVariable(player, "shoot_frame", "value_int", 0)
	
	-- adds simplified variable to player to make sure only the player is able to collect relics
	addNewSimplifiedInternalVariable(player, "arcane_reliquary_item_interact_flag")

	-- stores all default values used by this mod for later use
	storeDefaultPlayerValues()
	
	
	-- TESTING CODE BLOCKS
	----------------------
	-- temporary EDIT_WANDS_EVERYWHERE effect for testing purposes
	
	--[[
	local game_effect_comp = GetGameEffectLoadTo( player, "EDIT_WANDS_EVERYWHERE", true )
	if game_effect_comp ~= nil then
		ComponentSetValue( game_effect_comp, "frames", "-1" )
	end
	
	-- testing listener to monitor player properties
	
	component_id = EntityAddComponent(player, "LuaComponent", {
	  script_source_file = "mods/ArcaneReliquary/files/scripts/player/player_testing_listener.lua",
	  remove_after_executed = "0",
	  execute_every_n_frame = "10"
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	]]
	
	-- this is used to test wands and other entities added
	--local x, y = EntityGetTransform(player)
	
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/wandimprovenugget_mana.xml", x - 100, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/wandimprovenugget_mana.xml", x - 100, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/wandimprovenugget_mana.xml", x - 100, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/wrench_pink.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/cutting_board_blue_light.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/parry_shield_plastic.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/chest_key_black.xml", x - 100, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_chest_black.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/humid_gem.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/artifact_of_discipline.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/gravity_scepter_pink.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/wooden_monocular.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/relics/bag_of_magical_seeds.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/compact_store_room.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_utility_store.xml", x - 10, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_slot_machine.xml", x - 200, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_token.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/seed_water.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/props/relic_prize_machine.xml", x - 100, y)
	
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_metal_chunk.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_metal_chunk.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_metal_chunk.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_metal_chunk.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container.xml", x, y)
    --EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container_advanced.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container_advanced.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container_advanced.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/relic_upgrade_compound_container_advanced.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/healingnugget.xml", x - 60, y
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/suitcase_rocket.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/seed_lava.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/death_ray_pearl_ice.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/death_ray_pearl_fire.xml", x, y)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/items/death_ray_pearl_gold.xml", x, y)
	
	--EntityLoad("data/entities/props/physics/trap_laser.xml", x - 20, y)
	--EntityLoad("data/entities/props/physics_box_explosive.xml", x - 20, y)
	--EntityLoad("data/entities/props/physics/minecart.xml", x - 20, y)
	
	--EntityLoad("data/entities/items/pickup/moon.xml", x, y)
	--EntityLoad("data/entities/items/pickup/broken_wand.xml", x, y)
	--EntityLoad("data/entities/items/pickup/thunderstone.xml", x, y)
	--EntityLoad("data/entities/items/pickup/brimstone.xml", x, y)
	--EntityLoad("data/entities/items/pickup/physics_gold_orb.xml", x, y)
	
	--EntityLoad("data/entities/items/pickup/goldnugget_1000.xml", x, y)
	--EntityLoad("data/entities/items/pickup/goldnugget_1000.xml", x, y)
	--EntityLoad("data/entities/items/pickup/goldnugget_1000.xml", x, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/goldnugget.xml", x - 60, y)
	--EntityLoad("data/entities/items/pickup/beamstone.xml", x, y)
	
	--CreateItemActionEntity( "LIGHT_BULLET", x, y )
	--CreateItemActionEntity( "PROPANE_TANK", x, y )
	--CreateItemActionEntity( "PEBBLE", x, y )
	--CreateItemActionEntity( "RUBBER_BALL", x, y )
	--CreateItemActionEntity( "DYNAMITE", x, y )
	--CreateItemActionEntity( "ORBIT_LASERS", x, y )
	--CreateItemActionEntity( "BOMB", x, y )
	--CreateItemActionEntity( "GRENADE_TIER_3", x, y )
	--CreateItemActionEntity( "GRENADE", x, y )
	--CreateItemActionEntity( "DISC_BULLET_BIGGER", x, y )
	--CreateItemActionEntity( "DISC_BULLET_BIG", x, y )
	--CreateItemActionEntity( "NUKE", x, y )
	--CreateItemActionEntity( "ORBIT_DISCS", x, y )
	--CreateItemActionEntity( "MINE", x, y )
	--CreateItemActionEntity( "ELECTROCUTION_FIELD", x, y )
	--CreateItemActionEntity( "MINE", x, y )
	--CreateItemActionEntity( "BOUNCY_ORB", x, y )
	--CreateItemActionEntity( "SPIRAL_SHOT", x, y )
	--CreateItemActionEntity( "MAGIC_SHIELD", x, y)
	--CreateItemActionEntity( "SCATTER_2", x, y )
	--CreateItemActionEntity( "LIGHTNING", x, y )
	--CreateItemActionEntity( "MEGALASER", x, y )
	--CreateItemActionEntity( "MAGIC_SHIELD", x, y)
	--CreateItemActionEntity( "KNOCKBACK", x, y)
	--CreateItemActionEntity( "BALL_LIGHTNING", x, y)
	--CreateItemActionEntity( "FIREWORK", x, y)
	--CreateItemActionEntity( "ICEBALL", x, y)
	--CreateItemActionEntity( "FLAMETHROWER", x, y)
	--CreateItemActionEntity( "TENTACLE", x, y)
	--CreateItemActionEntity( "SLOW_BULLET", x, y)
	
	--CreateItemActionEntity( "TEMPORARY_WALL", x, y )
	--CreateItemActionEntity( "TEMPORARY_PLATFORM", x, y )
	
	--CreateItemActionEntity( "SWARM_FLY", x, y)
	--CreateItemActionEntity( "SWARM_WASP", x, y)
	--CreateItemActionEntity( "SWARM_FIREBUG", x, y)
	
	--perk_spawn( 750, -115, "FASTER_LEVITATION", true )
	--perk_spawn( x, y, "LEVITATION_TRAIL", true )
	--perk_spawn( x, y, "ATTACK_FOOT", true )
	--perk_spawn( x, y, "STRONG_KICK", true )
	
	--EntityLoad("data/entities/animals/wolf.xml", 730, -123)
	--EntityLoad("data/entities/animals/firemage.xml", 730, -123)
	--EntityLoad("data/entities/animals/sniper.xml", x - 60, y)
	--EntityLoad("data/entities/animals/scavenger_smg.xml", x - 60, y)
	--EntityLoad("data/entities/animals/scavenger_smg.xml", x - 60, y)
	--EntityLoad("data/entities/animals/miner.xml", x - 60, y)
	--EntityLoad("data/entities/animals/shotgunner.xml", 730, -123)
	--EntityLoad("data/entities/animals/monk.xml", 730, -123)
	--EntityLoad("mods/ArcaneReliquary/files/entity_definitions/companions/friendly_tank.xml", 730, -123)
	--EntityLoad("data/entities/animals/slimeshooter.xml", 730, -123)
	--EntityLoad("data/entities/animals/slimeshooter.xml", 735, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", x - 60, y)
	--EntityLoad("data/entities/animals/shotgunner.xml", 730, -123)
	--EntityLoad("data/entities/animals/shotgunner.xml", 730, -123)
	--EntityLoad("data/entities/animals/shotgunner.xml", 730, -123)
	EntityLoad("data/entities/animals/zombie.xml", 730, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", 730, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", 730, -123)
	--EntityLoad("data/entities/animals/boss_pit/boss_pit.xml", 730, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", 730, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", 730, -123)
	--EntityLoad("data/entities/animals/zombie_weak.xml", 730, -123)
	--EntityLoad("data/entities/animals/tentacler_small.xml", x - 60, y)
	--EntityLoad("data/entities/animals/slimeshooter.xml", 730, -123)
	--EntityLoad("data/entities/animals/longleg.xml", 730, -123)
	--EntityLoad("data/entities/animals/longleg.xml", 730, -123)
	--EntityLoad("data/entities/animals/longleg.xml", 730, -123)
	--EntityLoad("data/entities/animals/longleg.xml", 730, -123)
	
	----------------------
end

-- Initializes custom materials and reactions
ModMaterialsFileAdd("mods/ArcaneReliquary/files/custom_materials.xml" )